Package: triplex
Type: Package
Title: Search and visualize intramolecular triplex-forming sequences in
        DNA
Version: 1.51.0
Date: 2013-09-28
Authors@R: c(person("Jiri", "Hon", role = c("aut", "cre"),
                    email = "jiri.hon@gmail.com"),
             person("Matej", "Lexa", role = "aut",
                    email = "lexa@fi.muni.cz"),
             person("Tomas", "Martinek", role = "aut",
                    email = "martinto@fit.vutbr.cz"),
             person("Kamil", "Rajdl", role = "aut"),
             person("Daniel", "Kopecek", role = "ctb"))
Author: Jiri Hon, Matej Lexa, Tomas Martinek and Kamil Rajdl with contributions from Daniel Kopecek
Maintainer: Jiri Hon <jiri.hon@gmail.com>
Description: This package provides functions for identification and 
  visualization of potential intramolecular triplex patterns in DNA sequence.
  The main functionality is to detect the positions of subsequences capable of 
  folding into an intramolecular triplex (H-DNA) in a much larger sequence. 
  The potential H-DNA (triplexes) should be made of as many cannonical 
  nucleotide triplets as possible. The package includes visualization showing 
  the exact base-pairing in 1D, 2D or 3D.
License: BSD_2_clause + file LICENSE
URL: http://www.fi.muni.cz/~lexa/triplex/
biocViews: SequenceMatching, GeneRegulation
Depends: R (>= 2.15.0), S4Vectors (>= 0.5.14), IRanges (>= 2.5.27),
        XVector (>= 0.11.6), Biostrings (>= 2.39.10)
Imports: methods, grid, GenomicRanges
Suggests: rgl (>= 0.93.932), BSgenome.Celegans.UCSC.ce10, rtracklayer
LinkingTo: S4Vectors, IRanges, XVector, Biostrings
git_url: https://git.bioconductor.org/packages/triplex
git_branch: devel
git_last_commit: 53b853d
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-31
NeedsCompilation: yes
Packaged: 2025-11-01 00:43:18 UTC; biocbuild

###
## Triplex default score and isogroup tables
##
## Author: Jiri Hon
## Date: 2013/09/25
## Package: triplex
##


###
## Get default score tables
##
triplex.score.table <- function()
{
	names <- c("A", "C", "G", "T")
	mx <- matrix(TM, NBASES, NBASES, dimnames=list(names, names))
	tb <- list(par=mx, apar=mx)
	
	tb$par[T,A] <- TS
	tb$par[T,G] <- TW
	tb$par[C,G] <- TS
	tb$par[G,G] <- TW
	tb$par[G,T] <- TS
	tb$par[T,C] <- TW
	
	tb$apar[A,A] <- TS
	tb$apar[A,G] <- TW
	tb$apar[T,A] <- TS
	tb$apar[T,C] <- TW
	tb$apar[C,A] <- TW
	tb$apar[G,G] <- TS
	
	return(tb)
}

###
## Get default isogroup table
##
triplex.group.table <- function()
{
	names <- c("A", "C", "G", "T")
	mx <- matrix(IN, NBASES, NBASES, dimnames=list(names, names))
	tb <- list(par=mx, apar=mx)
	
	tb$par[T,A] <- IA
	tb$par[T,G] <- IA
	tb$par[C,G] <- IA
	tb$par[G,G] <- IB
	tb$par[G,T] <- IB
	tb$par[T,C] <- IB
	
	tb$apar[A,A] <- IC
	tb$apar[A,G] <- ID
	tb$apar[T,A] <- IC
	tb$apar[T,C] <- IE
	tb$apar[C,A] <- ID
	tb$apar[G,G] <- IE
	
	return(tb)
}

###
## Triplex align R interface
##
## Author: Jiri Hon
## Date: 2012/11/01
## Package: triplex
##


###
## Get DNA complementary strand
##
complement <- function(seq)
{
	chartr("atgcATGC", "tacgTACG", seq)
}


###
## Align triplex
##
triplex.align <- function(t)
{
	if (class(t) != "TriplexViews")
		stop("Triplex must be TriplexViews object")
	
	if (length(t) != 1)
		stop("TriplexViews object must be of length 1")
	
	seq <- subseq(subject(t), start(t), end(t))
	
	p <- t@params
	p[MIN_LOOP] <- to_double(lwidth(t))
	type <- to_double(type(t))
	
	triplex <- .Call(
		"triplex_align", seq, type, p,
		t@score_table$par, t@score_table$apar,
		t@group_table$par, t@group_table$apar
	)
	
	# Make reverse complement
	if (strand(t) == "-")
		triplex <- reverse(complement(triplex))
	
	return(triplex)
}


###
## Convert triplex alignment into DNAStringSet
##
alignment.DNAStringSet <- function(alignment, type)
{
	n <- nchar(alignment)
	seq <- substring(alignment, 1:n, 1:n)
	loop <- which(seq == "=")
	
	seq.left <- paste(seq[1:(loop[1] - 1)], collapse='')
	seq.loop <- paste(seq[(loop[1] + 1):(loop[2] - 1)], collapse='')
	seq.right <- paste(seq[(loop[2] + 1):n], collapse='')
	
	if (type == 0)
	{
		a <- DNAStringSet(c(
			seq.left,
			complement(seq.left),
			reverse(seq.right),
			seq.loop))
		names(a) <- c(
			"plus",
			"minus",
			"para-plus",
			"loop")
	}
	else if (type == 1)
	{
		a <- DNAStringSet(c(
			seq.left,
			reverse(complement(seq.right)),
			reverse(seq.right),
			seq.loop))
		names(a) <- c(
			"para-plus",
			"minus",
			"plus",
			"loop")
	}
	else if (type == 2)
	{
		a <- DNAStringSet(c(
			seq.left,
			reverse(complement(seq.right)),
			reverse(seq.right),
			seq.loop))
		names(a) <- c(
			"para-minus",
			"plus",
			"minus",
			"loop")
	}
	else if (type == 3)
	{
		a <- DNAStringSet(c(
			seq.left,
			complement(seq.left),
			reverse(seq.right),
			seq.loop))
		names(a) <- c(
			"minus",
			"plus",
			"para-minus",
			"loop")
	}
	else if (type == 4)
	{
		a <- DNAStringSet(c(
			reverse(complement(seq.right)),
			reverse(seq.right),
			seq.left,
			seq.loop))
		names(a) <- c(
			"plus",
			"minus",
			"anti-minus",
			"loop")
	}
	else if (type == 5)
	{
		a <- DNAStringSet(c(
			reverse(seq.right),
			seq.left,
			complement(seq.left),
			seq.loop))
		names(a) <- c(
			"anti-minus",
			"minus",
			"plus",
			"loop")
	}
	else if (type == 6)
	{
		a <- DNAStringSet(c(
			reverse(seq.right),
			seq.left,
			complement(seq.left),
			seq.loop))
		names(a) <- c(
			"anti-plus",
			"plus",
			"minus",
			"loop")
	}
	else
	{
		a <- DNAStringSet(c(
			reverse(complement(seq.right)),
			reverse(seq.right),
			seq.left,
			seq.loop))
		names(a) <- c(
			"minus",
			"plus",
			"anti-plus",
			"loop")
	}
	return(a)
}


###
## Get triplex alignment for further processing
##
triplex.alignment <- function(triplex)
{
	alignment <- triplex.align(triplex)
	type <- type(triplex)
	alignment.DNAStringSet(alignment, type)
}

###
## Triplex search R interface
##
## Author: Jiri Hon
## Date: 2012/10/15
## Package: triplex
##

###
## Check if type vector is valid
##
validate_type <- function(type)
{
	if (mode(type) != "numeric")
		stop("Triplex type must be a numeric vector, see ?triplex.search")
	
	type <- unique(as.integer(type))
		
	if (length(type) > 8 ||
	    min(type) < 0 ||
	    max(type) > 7)
	{
		stop("Invalid triplex type vector, see ?triplex.search")
	}
	return(type)
}

###
## Validate sequence type
##
validate_seq_type <- function(seq_type)
{
	# Validate sequence type option
	if (seq_type == 'prokaryotic')
		seq_type = as.integer(ST_PROKARYOTIC)
	else if (seq_type == 'eukaryotic')
		seq_type = as.integer(ST_EUKARYOTIC)
	else
		stop("Invalid sequence type. Valid options are prokaryotic or eukaryotic.")
}

###
## Validate score or group table
##
validate_table <- function(table, type)
{
	if (table == 'default')
	{# Return default tables
		if (type == 'score')
			table <- triplex.score.table()
		else if (type == 'group')
			table <- triplex.group.table()
	}
	
	if (is.null(table$par) || is.null(table$apar))
		stop("Incomplete custom table.")
	
	if (!setequal(dim(table$par), dim(table$apar)) || !setequal(dim(table$par), c(NBASES, NBASES)))
		stop("Invalid size of custom table.")
	
	table$par <- as.integer(table$par)
	table$apar <- as.integer(table$apar)
	
	return(table)
}

###
## Convert storage mode to double if possible
##
to_double <- function(val)
{
	if (mode(val) != "numeric")
		stop("Invalid parameter, use numeric values please.")
	
	return(as.double(val))
}

###
## Set penalization value
##
pen_set <- function(value, default)
{
	if (value == 'default')
		return(default)
	else
		return(value)
}

###
## Set P-value constant
##
pconst_set <- function(value, prokaryotic, eukaryotic)
{
	if (value == 'default')
		return(c(prokaryotic, eukaryotic))
	else
		return(c(value, value))
}

###
## Search input sequence for triplexes
##
triplex.search <- function(
	dna,
	type        = 0:7,
	min_score   = 15,
	p_value     = 0.05,
	min_len     = 6,
	max_len     = 25,
	min_loop    = 3,
	max_loop    = 10,
	seq_type    = 'eukaryotic',
	score_table = 'default',
	group_table = 'default',
	lambda_par  = 'default',
	lambda_apar = 'default',
	mu_par      = 'default',
	mu_apar     = 'default',
	rn_par      = 'default',
	rn_apar     = 'default',
	dtwist_pen  = 'default', #7,
	ins_pen     = 'default', #9,
	iso_pen     = 'default', #5,
	iso_bonus   = 'default', #0,
	mis_pen     = 'default') #7)
{
	if (class(dna) != "DNAString")
		stop("Input sequence must be DNAString object.")
	
	if (min_loop < 1)
		stop("Can not search triplexes whithout a loop.")
	
	if (max_loop < min_loop)
		stop("max_loop option can not be lower than min_loop.")
	
	if (min_len < 1)
		stop("Can not search triplexes whithout a body.")
	
	if (max_len < min_len)
		stop("max_len option can not be lower than min_len.")
	
	if (dtwist_pen != 'default' || ins_pen != 'default' ||
		 iso_pen != 'default' || iso_bonus != 'default' ||
		 mis_pen != 'default')
		warning(
			'Default penalization options were changed. You should consider recalculation
			of P-value constants (mu, lambda, rn). For details see vignette.')
	
	if (score_table != 'default' || group_table != 'default')
		warning(
			'Default scoring tables or isgroup tables were changed. You should consider
			recalculation of P-value constants (mu, lambda, rn). For details see vignette.')
	
	# Set default penalizations
	dtwist_pen = pen_set(dtwist_pen, 7)
	ins_pen    = pen_set(ins_pen, 9)
	iso_pen    = pen_set(iso_pen, 5)
	iso_bonus  = pen_set(iso_bonus, 0)
	mis_pen    = pen_set(mis_pen, 7)
	
	###
	## Set default P-value constants
	##
	## Triplexfit output as reported by Matej Lexa on 2013-04-30:
	##
	## Sequence length: 4800000
	##
	## Ecoli_par:  mu = 7.4805, lambda = 0.8892, hits = 194641, rn = 0.0406
	## Ecoli_apar: mu = 7.6569, lambda = 0.8092, hits = 130954, rn = 0.0273
	## Human_par:  mu = 7.5835, lambda = 0.8433, hits = 145915, rn = 0.0304
	## Human_apar: mu = 7.9611, lambda = 0.6910, hits = 194391, rn = 0.0405
	
	lambda_par = pconst_set(lambda_par, 0.8892, 0.8433)
	lambda_apar = pconst_set(lambda_apar, 0.8092, 0.6910)
	mu_par = pconst_set(mu_par, 7.4805, 7.5835)
	mu_apar = pconst_set(mu_apar, 7.6569, 7.9611)
	rn_par = pconst_set(rn_par, 0.0406, 0.0304)
	rn_apar = pconst_set(rn_apar, 0.0273, 0.0405)
	
	# Check and convert parameters to double
	p <- double()
	p[MIN_SCORE]     = to_double(min_score)
	p[P_VALUE]       = to_double(p_value)
	p[MIN_LEN]       = to_double(min_len)
	p[MAX_LEN]       = to_double(max_len)
	p[MIN_LOOP]      = to_double(min_loop)
	p[MAX_LOOP]      = to_double(max_loop)
	p[LAMBDA_PAR_P]  = to_double(lambda_par[1])
	p[LAMBDA_PAR_E]  = to_double(lambda_par[2])
	p[LAMBDA_APAR_P] = to_double(lambda_apar[1])
	p[LAMBDA_APAR_E] = to_double(lambda_apar[2])
	p[MU_PAR_P]      = to_double(mu_par[1])
	p[MU_PAR_E]      = to_double(mu_par[2])
	p[MU_APAR_P]     = to_double(mu_apar[1])
	p[MU_APAR_E]     = to_double(mu_apar[2])
	p[RN_PAR_P]      = to_double(rn_par[1])
	p[RN_PAR_E]      = to_double(rn_par[2])
	p[RN_APAR_P]     = to_double(rn_apar[1])
	p[RN_APAR_E]     = to_double(rn_apar[2])
	p[DTWIST_PEN]    = to_double(dtwist_pen)
	p[INS_PEN]       = to_double(ins_pen)
	p[ISO_PEN]       = to_double(iso_pen)
	p[ISO_BONUS]     = to_double(iso_bonus)
	p[MIS_PEN]       = to_double(mis_pen)
	
	type <- validate_type(type)
	seq_type <- validate_seq_type(seq_type)
	score_table <- validate_table(score_table, 'score')
	group_table <- validate_table(group_table, 'group')
	
	txs <- .Call(
		"triplex_search", dna, type, seq_type, p,
		score_table$par, score_table$apar,
		group_table$par, group_table$apar,
		as.integer(getOption("width"))
	)
	
	strand <- txs[[T_STRAND]]
	s <- character()
	s[strand == 0] <- "+"
	s[strand == 1] <- "-"
	
	tx_views <- TriplexViews(
		dna,
		start  = txs[[T_START]],
		end    = txs[[T_END]],
		score  = txs[[T_SCORE]],
		pvalue = txs[[T_P_VALUE]],
		insdel = txs[[T_INSDEL]],
		type   = txs[[T_TYPE]],
		lstart = txs[[T_L_START]],
		lend   = txs[[T_L_END]],
		strand = s,
		params = p,
		score_table = score_table,
		group_table = group_table
	)
	if (length(start(tx_views)) == 0)
		message(paste(
			"NOTICE: There was no triplexes found with the given options.\n",
			"TIP: Try to modify search options (p_value, min_score, etc.),\n",
			"     for details see ?triplex.search.",
		sep=''))
	
	return(tx_views)
}

###
## Diagram triplex visualization
##
## Author: Kamil Rajdl, Jiri Hon
## Date: 2012/10/28
## Package: triplex
##


###
## This function computes necessary information to draw a triplex using one of
## function for triplex visualization.
## 
## triplex TriplexViews object
##
## RETURN: list containing the following components:
## DNAseq1  sequence of nucletides of the main (bent) thread of triplex
## DNAseq2  sequence of nucletides of the third thread of triplex
## Wbonds   matrix with numbers of nucleotides conected with W-C bonds, the 
##            matrix has two rows with corresponding numbers of nucleotides 
## Hbonds   matrix with numbers of nucleotides conected with Hoogsteen bonds, 
##            the matrix has two rows with corresponding numbers of nucleotides 
## bends    vector with informations about bending (sequence number of 
##            nucleotide beyond which starts bending and sequence number of 
##            nucleotide before which ends bending)
##
triplex.input <- function(view)
{
	triplex <- triplex.align(view)
	triplex.type <- type(view)
	
	m = nchar(triplex);
	triplex.vec <- toupper(substring(triplex, 1:m, 1:m));
	DNAseq.vec <- toupper(triplex.vec[-which((triplex.vec == "=")|(triplex.vec == "-"))]);
	DNAseq1 <- paste(DNAseq.vec, collapse = '')
	n <- length(DNAseq.vec);
	bends <- which(triplex.vec == "=");   
	gaps <- which(triplex.vec == "-"); 
	
	# Input conditions ====================
	
	# Input string conditions
	if (!all(triplex.vec %in% c("A","T","C","G","=","-"))) {
		stop("Input string contains illegal characters.");
	}
	if (length(bends) != 2) {
		stop("Wrong number of '=' characters (exactly two are needed).");
	}
	if ((bends[1] == 1) || (bends[2] == m)) {
		stop("Input string must not start or end with '=' character.");
	}
	if (length(triplex.vec[1:(bends[1]-1)]) != length(triplex.vec[(bends[2]+1):m])) {
		l.part <- length(triplex.vec[1:(bends[1]-1)]);
		r.part <- length(triplex.vec[(bends[2]+1):m]);
		stop(paste(c("Left and right part of input string are not the same length. (L=",l.part,",R=",r.part,")"), collapse = ""));
	}
	for (i in gaps) {
		if (i %in% c(1,m)) {
			stop("Input string must not start or end with '-' character.");
		}
		if ((i > bends[1]) && (i < bends[2])) {
			stop("Character '-' must not be between '=' characters.");
		}  
	}
	
	# triplex.type condition
	if (!(triplex.type %in% c(0,1,2,3,4,5,6,7))) {
		stop("wrong triplex.type");
	}
	
	# ======================================
	
	# creation of matrix of "pre-bonds"
	bonds <- numeric(0);
	ind1 = 1;
	ind2 = n;
	for (i in 1:(bends[1]-1)) {
		if ((triplex.vec[i] != "-") && (triplex.vec[m+1-i]) != "-") {
			bonds <- cbind(bonds, c(ind1, ind2));
		}
		if (triplex.vec[i] != "-") {
			ind1 <- ind1+1;
		} 
		if (triplex.vec[m+1-i] != "-") {
			ind2 <- ind2-1;
		}   
	} 
	# creation of matrices of W-C and Hoogsteen bonds and of the third thread
	Wbonds <- numeric(0);
	Hbonds <- numeric(0);
	DNAseq2 <- "";
	bonds.count <- dim(bonds)[2];
	
	if (triplex.type %in% c(0,3)) {
		for (i in 1:bonds.count) {
			Wbonds <- cbind(Wbonds, c(bonds[1,i], bonds.count-i+1));
			Hbonds <- cbind(Hbonds, c(bonds[2,i], bonds.count-i+1));
			DNAseq2 <- paste(complementary(DNAseq.vec[bonds[1,i]]), DNAseq2, sep="");   
		}
	}
	
	if (triplex.type %in% c(1,2)) {
		for (i in 1:bonds.count) {
			Wbonds <- cbind(Wbonds, c(bonds[2,i], i));
			Hbonds <- cbind(Hbonds, c(bonds[1,i], i));
			DNAseq2 <- paste(DNAseq2, complementary(DNAseq.vec[bonds[2,i]]), sep="");   
		}
	}
	
	if (triplex.type %in% c(4,7)) {
	Hbonds <- bonds;
		for (i in 1:bonds.count) {
			Wbonds <- cbind(Wbonds, c(bonds[2,i], i));
			DNAseq2 <- paste(DNAseq2, complementary(DNAseq.vec[bonds[2,i]]), sep="");   
		}
	}
	
	if (triplex.type %in% c(5,6)) {
	Hbonds <- bonds;
		for (i in 1:bonds.count) {
			Wbonds <- cbind(Wbonds, c(bonds[1,i], bonds.count-i+1));
			DNAseq2 <- paste(complementary(DNAseq.vec[bonds[1,i]]), DNAseq2, sep="");     
		}
	}
	
	# bends positions in DNAseq1
	gn <- length(gaps[gaps<bends[1]]);
	bends <- c(bends[1]-1-gn, bends[2]-1-gn);
	npl <- bends[1] - max(bonds[1,]);
	npr <- min(bonds[2,]) - bends[2];
	
	bends <- c(bends[1]-npl, bends[2]+npr);
	
	result <- list(DNAseq1, DNAseq2, Wbonds, Hbonds, bends, alignment.DNAStringSet(triplex, triplex.type));
	return(result);
}


###
## Get complementary nuclotide
##
complementary <- function(N)
{
	comp <- "A";

	if(N == "A") {
		comp <- "T";
	}
	if(N == "T") {
		comp <- "A";
	}
	if(N == "G") {
		comp <- "C";
	}
	if(N == "C") {
		comp <- "G";
	}
	return(comp);
}

###
## Constants for triplex search and align R interface
##
## Author: Jiri Hon
## Date: 2012/10/28
## Package: triplex
##

###
## Parameter positions in parameter array
## for passing from/to C function
##
MIN_SCORE     = 1
P_VALUE       = 2
MIN_LEN       = 3
MAX_LEN       = 4
MIN_LOOP      = 5
MAX_LOOP      = 6
LAMBDA_PAR_P  = 7
LAMBDA_PAR_E  = 8
LAMBDA_APAR_P = 9
LAMBDA_APAR_E = 10
MU_PAR_P      = 11
MU_PAR_E      = 12
MU_APAR_P     = 13
MU_APAR_E     = 14
RN_PAR_P      = 15
RN_PAR_E      = 16
RN_APAR_P     = 17
RN_APAR_E     = 18
DTWIST_PEN    = 19
INS_PEN       = 20
ISO_PEN       = 21
ISO_BONUS     = 22
MIS_PEN       = 23

###
## Positions in result list from C
##
T_START    = 1
T_END      = 2
T_SCORE    = 3
T_P_VALUE  = 4
T_INSDEL   = 5
T_TYPE     = 6
T_L_START  = 7
T_L_END    = 8
T_STRAND   = 9

###
## Prokaryotic vs. eukaryotic
##
ST_PROKARYOTIC = 0
ST_EUKARYOTIC  = 1
ST_AUTOMATIC   = 2 # Not supported yet


###
## Score/group table size
##
NBASES = 4

###
## Scoring constants
##
TM = -9
TS = 2
TW = 1

###
## Isomorphic group constants
##
IN = 0
IA = 1
IB = 2
IC = 1
ID = 2
IE = 3

###
## Nucleic acids constants
##
A = 1
C = 2
G = 3
T = 4

###
## TriplexViews class
##
## The TriplexViews class is the container for storing a set of triplex views
## (start/end locations, score, pvalue, etc.) on the same DNAString object,
## called the "subject" string.
##
## Author: Jiri Hon
## Date: 2012/10/21
## Package: triplex
##

setClass("TriplexViews",
	contains = "XStringViews",
	representation(
		params="numeric",
		score_table="list",
		group_table="list"
	)
)


###
## User-friendly constructor
##
TriplexViews <- function(
	subject, start, end, score, pvalue, insdel,
	type, lstart, lend, strand, params,
	score_table, group_table)
{
	view <- IRanges:::new_Views(
		subject,
		start = start, end = end,
		Class = "TriplexViews"
	)
	view@params <- params
	view@score_table <- score_table
	view@group_table <- group_table
	
	mcols(view) <- DataFrame(
		score  = score,
		pvalue = pvalue,
		insdel = insdel,
		type   = type,
		lstart = lstart,
		lend   = lend,
		strand = strand
	)
	return(view)
}


###
## Set accessors to element metadata
##
setMethod("score", "TriplexViews", function(x) mcols(x)$score)

setGeneric("pvalue", function(x, ...) standardGeneric("pvalue"))
setMethod("pvalue", "TriplexViews", function(x) mcols(x)$pvalue)

setGeneric("ins", function(x, ...) standardGeneric("ins"))
setMethod("ins", "TriplexViews", function(x) mcols(x)$insdel)

setMethod("type", "TriplexViews", function(x) mcols(x)$type)

setGeneric("lstart", function(x, ...) standardGeneric("lstart"))
setMethod("lstart", "TriplexViews", function(x) mcols(x)$lstart)

setGeneric("lend", function(x, ...) standardGeneric("lend"))
setMethod("lend", "TriplexViews", function(x) mcols(x)$lend)

setMethod("strand", "TriplexViews", function(x) mcols(x)$strand)

setGeneric("lwidth", function(x, ...) standardGeneric("lwidth"))
setMethod("lwidth", "TriplexViews", function(x)
{
	mcols(x)$lend - mcols(x)$lstart + 1
})


###
## The 2 helper functions below convert a given view on an XString object
## into a character-string.
##
## Both assume that 'start' <= 'end' (so they don't check it) and
## padd the result with spaces to produce the "margin effect"
## if 'start' or 'end' are out of limits.
##
## NOTE: Copied from Biostrings package, file XStringViews-class.R
##

###
## nchar(get_view(x, start, end)) is always end-start+1
##
get_view <- function(x, start, end, strand)
{
	s <- DNAString(subseq(x, start, end))
	if (strand == "-") s <- reverseComplement(s)
	as.character(s)
}

###
## nchar(get_snippet(x, start, end, snippetWidth)) is <= snippetWidth
##
get_snippet <- function(x, start, end, snippetWidth, strand)
{
	if (snippetWidth < 7)
		snippetWidth <- 7
	width <- end - start + 1
	if (width <= snippetWidth) {
		get_view(x, start, end, strand)
	} else {
		w1 <- (snippetWidth - 2) %/% 2
		w2 <- (snippetWidth - 3) %/% 2
		paste(get_view(x, start, start+w1-1, strand),
		      "...",
		      get_view(x, end-w2+1, end, strand), sep="")
	}
}


###
## Show header of output table
## NOTE: Based on function from Biostrings package
##
show_vframe_header <- function(iW, cols)
{
	cat(format("", width=iW)) # Print padding
	
	for (col in cols)
	{# Print column names
		cat(" ")
		cat(format(col$nm, width=col$width, justify="right"))
	}
	cat("\n")
}


###
## Show row of output table
## NOTE: Based on function from Biostrings package
##
show_vframe_line <- function(x, i, iW, cols)
{
	# Print triplex index
	cat(format(paste("[", i,"]", sep=""), width=iW, justify="right"))
	
	colW <- 0 # Summary of all column width
	
	for (col in cols)
	{# Print column values
		cat(" ")
		value <- do.call(col$fn, list(x))[i]
		cat(do.call("format", c(value, col[3:length(col)], justify="right")))
		
		colW = colW + col$width
	}
	snippetW <- getOption("width") - iW - colW - length(cols) - 3
	cat(" [",
	    get_snippet(subject(x), start(x)[i], end(x)[i], snippetW, strand(x)[i]),
	    "]\n", sep="")
}


###
## Shot dots for not showed table rows
##
show_vframe_line_dots <- function(x, iW, cols)
{
	cat(format("...", width=iW, justify="right"))
	
	for (col in cols) {
		cat(" ")
		cat(format("...", width=col$width, justify="right"))
	}
	cat("\n")
}


###
## Show all output table rows
## NOTE: Based on function from Biostrings package
## 'half_nrow' must be >= 1
##
show_vframe <- function(x, half_nrow=9L)
{
	###
	## Column definitions
	## nm = Column header
	## fn = Function name to get row values
	## ... other parameters passed to format function
	##
	cols <- list(
		list(nm="start",  fn="start"),
		list(nm="width",  fn="width"),
		list(nm="score",  fn="score"),
		list(nm="pvalue", fn="pvalue", scientific=TRUE, digits=2),
		list(nm="ins",    fn="ins"),
		list(nm="type",   fn="type"),
		list(nm="s",      fn="strand")
	)
	
	i <- 1
	for (col in cols)
	{# Calculate column widths
		col_max <- max(do.call(col$fn, list(x)))
		col_maxstr <- do.call("format", c(col_max, col[3:length(col)]))
		cols[[i]] <- c(col, width=max(nchar(col_maxstr), nchar(col$nm)))
		i = i + 1
	}
	
	lx <- length(x)
	iW <- nchar(format(lx)) + 2 # Two extra for square brackets
	
	show_vframe_header(iW, cols)
	
	if (lx <= 2*half_nrow + 1)
	{# Show all
		for (i in seq_len(lx))
			show_vframe_line(x, i, iW, cols)
	}
	else
	{# Show first and last views
		for (i in 1:half_nrow)
			show_vframe_line(x, i, iW, cols)
		
		show_vframe_line_dots(x, iW, cols)
		
		for (i in (lx-half_nrow+1L):lx)
			show_vframe_line(x, i, iW, cols)
	}
}


###
## Show method, automatically invoked by print command
## NOTE: Based of function from Biostrings package
##
setMethod("show", "TriplexViews", function(object)
{
	subject <- subject(object)
	lsub <- length(subject)
	
	cat("  Triplex views on a ", lsub, "-letter ", class(subject),
			" subject", sep="")
	cat("\nsubject:", get_snippet(subject, 1, lsub, getOption("width") - 9, "+"))
	cat("\ntriplexes:")
	
	if (length(object) == 0) {
		cat(" NONE\n")
	}
	else {
		cat("\n")
		show_vframe(object)
	}
})


###
## Coerce TriplexViews to DNAStringSet
##
setAs("TriplexViews", "DNAStringSet", function(from)
{
	s <- DNAStringSet(subject(from), start(from), end(from))
	rev_cmpl <- strand(from) == "-"
	s[rev_cmpl] <- reverseComplement(s[rev_cmpl])
	
	for (i in 1:length(s))
	{# Set proper names
		names(s)[i] <- paste(
			"start=", start(from)[i], ";",
			"end=", end(from)[i], ";",
			"score=", score(from)[i], ";",
			"pvalue=", format(pvalue(from)[i], scientific=TRUE, digits=2), ";",
			"ins=", ins(from)[i], ";",
			"type=", type(from)[i], ";",
			"strand=", strand(from)[i], sep=""
		)
	}
	return(s)
})


###
## Coerce TriplexViews to GRanges
##
setAs("TriplexViews", "GRanges", function(from)
{
	seqlen <- length(subject(from))
	names(seqlen) <- "chr1"
	
	GRanges(
		"chr1",
		IRanges(start(from), end(from)),
		strand(from),
		score = score(from),
		tritype = type(from),
		pvalue = format(pvalue(from), scientific=TRUE, digits=2),
		lstart = lstart(from),
		lend = lend(from),
		indels = ins(from),
		seqlengths = seqlen
	)
})


### - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
### Subsetting.
###

### Always behaves like an endomorphism (i.e. ignores the 'drop' argument and
### behaves like if it was actually set to FALSE).
# setMethod("[", "TriplexViews", function(x, i, j, ..., drop=TRUE)
# {
# 	if (!missing(j) || length(list(...)) > 0L)
# 		stop("invalid subsetting")
# 	if (missing(i))
# 		i <- seq_len(length(x))
# 	
# 	tx_views <- TriplexViews(
# 		subject(x),
# 		start  = start(x)[i],
# 		end    = end(x)[i],
# 		score  = score(x)[i],
# 		pvalue = pvalue(x)[i],
# 		insdel = ins(x)[i],
# 		type   = type(x)[i],
# 		lstart = lstart(x)[i],
# 		lend   = lend(x)[i],
# 		strand = strand(x)[i],
# 		params = x@params,
# 		score_table = x@score_table,
# 		group_table = x@group_table
# 	)
# 	return(tx_views)
# })


###
## Coerce to character vector
##
setMethod("as.character", "TriplexViews", function(x)
{
	s <- as(x, "DNAStringSet")
	as.character(s)
})


###
## Convert to printable string
##
setMethod("toString", "TriplexViews", function(x, ...)
{
	toString(as.character(x), ...)
})

###
## Diagram triplex visualization
##
## Author: Kamil Rajdl
## Date: 2012/10/28
## Package: triplex
##


###
## This function draws a 2-D representation of a triplex 
##
## triplex      TriplexViews object
## circles      TRUE - nucleotides are drawn as characters in circles
##              FALSE - nucleotides are drawn just as characters
## wcbonds.lty  type of Watson-Crick bonds lines
## hbonds.lty   type of Hoogsteen bonds lines
## mbonds.lty   type of main (skelet) bonds lines
## wcbonds.lwd  width of Watson-Crick bonds lines
## hbonds.lwd   width of Hoogsteen bonds lines
## mbonds.lwd   width of main (skelet) bonds lines
## labels.cex   multiplier of size of labels of nucleotides
## circles.cex  multiplier of size of nucleotides
## margin       left and right margin of the picture
##
triplex.diagram <- function(
	triplex,
	circles = TRUE,
	mbonds.lty = 1,
	mbonds.lwd = 2.5,
	wcbonds.lty = 1,
	wcbonds.lwd = 1,
	hbonds.lty = 2,
	hbonds.lwd = 1,
	labels.cex = 1,
	circles.cex = 1,
	margin = 0.1,
	bonds.length = 0.07)
{
	# processing of inputs
	results <- triplex.input(triplex);
	triplex.type <- type(triplex);

	DNAseq1 <- results[[1]];
	DNAseq2 <- results[[2]];
	WCbonds <- results[[3]];
	Hbonds <- results[[4]];
	bends <- results[[5]];
	alignment <- results[[6]];

	# input condition
	if ((margin<0) || (margin>=0.5)) {
		stop("xmargin have to be from interval [0,0.5).");
	}

	# initial parameters and variables 
	bend.start <- bends[1];
	bend.end <- bends[2];       
	xsize <- 1-2*margin;
	n.bonds <- dim(WCbonds)[2];
	n.bend <- bend.end - bend.start - 1;
	n.seq1 <- nchar(DNAseq1);
	n.seq2 <- nchar(DNAseq2);
	dist2 <- bonds.length;                                # length of Watson-Crick and Hoogsteen bonds
	dist1 <- xsize/(n.bonds+(n.bend+2)^2/((n.bend+1)*pi)); # distance between nucleotides in sequence
	if (dist1 > 0.07) {
		dist1 = 0.07;
		xsize = dist1*(n.bonds+(n.bend+2)^2/((n.bend+1)*pi));
		margin = (1-xsize)/2;
		
	}

	# division of Hoogsteen bonds into DNAseq1-DNAseq1 bonds and DNAseq1-DNAseq2 bonds
	if (triplex.type %in% c("0","1","2","3")) {
		Hbonds1 <- Hbonds;
		Hbonds2 <- matrix(0,2,0);
	}
	if (triplex.type %in% c("4","5","6","7")) {
		Hbonds1 <- matrix(0,2,0);
		Hbonds2 <- Hbonds;
	}

	# processing of sequences into vector of characters
	DNAseq1.vec <- substring(DNAseq1, 1:n.seq1, 1:n.seq1);
	DNAseq2.vec <- substring(DNAseq2, 1:n.seq2, 1:n.seq2);

	# x-coordinates of paired nucleotides (the rest is set to NA for now)
	seq1.xcoords <- rep(NA, n.seq1);
	j <- 1;
	for (i in 1:bend.start) {
		if ((i %in% WCbonds[1,]) || (i %in% Hbonds1[1,]) ||  (i %in% Hbonds2)) {
			seq1.xcoords[i] <- margin+j*dist1;
			j <- j+1;   
		}
	}
	j <- 1;
	for (i in n.seq1:bend.end) {
		if ((i %in% WCbonds[1,]) || (i %in% Hbonds1[1,]) ||  (i %in% Hbonds2)) {
			seq1.xcoords[i] <- margin+j*dist1;
			j <- j+1;   
		}
	}

	# coordinates of direction labels (3', 5')
	dirlab.xcoords <- c(margin, margin, margin); 
	dirlab.ycoords <- c(0.5+dist2, 0.5, 0.5-dist2); 

	# the remaining coordinates of paired nucleotides and creation of direction labels
	if (triplex.type %in% c(0,3)) {
		seq1.ycoords <- c(rep(0.5+dist2, bend.start), rep(NA, n.bend), 
		                  rep(0.5-dist2, n.seq1-bend.end+1));    
		seq2.xcoords <- seq(from=margin+dist1*n.bonds, to=margin+dist1, by=-dist1);
		seq2.ycoords <- rep(0.5, n.bonds);

		dirlab <- textGrob(c("5'","3'","3'"), dirlab.xcoords, dirlab.ycoords);                   
	}
	if (triplex.type %in% c(1,2)) {
		seq1.ycoords <- c(rep(0.5+dist2, bend.start), rep(NA, n.bend), 
		                  rep(0.5-dist2, n.seq1-bend.end+1));  
		seq2.xcoords <- seq(from=margin+dist1, to=margin+dist1*n.bonds, by=dist1);
		seq2.ycoords <- rep(0.5, n.bonds);

		dirlab <- textGrob(c("5'","5'","3'"), dirlab.xcoords, dirlab.ycoords); 
	}
	if (triplex.type %in% c(4,7)) {
		seq1.ycoords <- c(rep(0.5-dist2, bend.start), rep(NA, n.bend), 
		                  rep(0.5, n.seq1-bend.end+1));     
		seq2.xcoords <- seq(from=margin+dist1, to=margin+dist1*n.bonds, by=dist1);
		seq2.ycoords <- rep(0.5+dist2, n.bonds);

		dirlab <- textGrob(c("5'","3'","5'"), dirlab.xcoords, dirlab.ycoords);  
	}
	if (triplex.type %in% c(5,6)) {
		seq1.ycoords <- c(rep(0.5, bend.start), rep(NA, n.bend), 
		                  rep(0.5+dist2, n.seq1-bend.end+1));    
		seq2.xcoords <- seq(from=margin+dist1*n.bonds, to=margin+dist1, by=-dist1);
		seq2.ycoords <- rep(0.5-dist2, n.bonds);

		dirlab <- textGrob(c("3'","5'","3'"), dirlab.xcoords, dirlab.ycoords);  
	}

	# coordinates of nucleotiodes in the bend
	if ((bend.end-bend.start)>1) {
		x1 <- c(seq1.xcoords[bend.start], seq1.ycoords[bend.start]);
		x2 <- c(seq1.xcoords[bend.end], seq1.ycoords[bend.end]);
		S <- c(x1[1]+dist1*(n.bend+1)/(2*pi), (x1[2]+x2[2])/2);
		y <- abs(x1[2]-x2[2])/2;
		r <- sqrt((x1[1]-S[1])^2+(x1[2]-S[2])^2);
		alpha1 <- asin(y/r);
		alpha2 <- (2*pi-2*alpha1)/(n.bend+1);
		for (i in (bend.start+1):(bend.end-1)) {
			if (triplex.type %in% c(0,1,2,3)) {
				seq1.xcoords[i] <- S[1] + r*cos(pi-alpha1-(i-bend.start)*alpha2);
				seq1.ycoords[i] <- S[2] + r*sin(pi-alpha1-(i-bend.start)*alpha2);
			}
			if (triplex.type %in% c(4,5,6,7)) {
				seq1.xcoords[i] <- S[1] + r*cos(pi+alpha1+(i-bend.start)*alpha2);
				seq1.ycoords[i] <- S[2] + r*sin(pi+alpha1+(i-bend.start)*alpha2);
			}
		}
	}

	# coordinates of nucleotides opposite the gaps
	for (i in 1:n.seq1) {
		if (is.na(seq1.xcoords[i])) {
			j<-1
			while (is.na(seq1.xcoords[i+j])) {
				j<-j+1;
			}
			x1 <- c(seq1.xcoords[i-1], seq1.ycoords[i-1]);
			x2 <- c(seq1.xcoords[i+j], seq1.ycoords[i+j]);
			y <- abs(x1[1]-x2[1])/2;
			z <- dist1*(j+1)/(2*pi);
			down = ((triplex.type %in% c(0,1,2,3)) && (i >= bend.end)) || 
			       ((triplex.type %in% c(4,7)) && (i <= bend.start));
			if (down) {
				S <- c((x1[1]+x2[1])/2, x1[2]-z);
			} else {
				S <- c((x1[1]+x2[1])/2, x1[2]+z); 
			}
			r <- sqrt((x1[1]-S[1])^2+(x1[2]-S[2])^2);
			alpha1 <- asin(y/r);
			alpha2 <- (2*pi-2*alpha1)/(j+1);
			if ((x1[1] < x2[1]) && (!down)) {
				for (k in i:(i+j-1)) {
					seq1.xcoords[k] <- S[1] + r*cos(-pi/2-alpha1-(k-i+1)*alpha2);
					seq1.ycoords[k] <- S[2] + r*sin(-pi/2-alpha1-(k-i+1)*alpha2);
				}
			}
			if ((x1[1] < x2[1]) && (down)) {
				for (k in i:(i+j-1)) {
					seq1.xcoords[k] <- S[1] + r*cos(pi/2+alpha1+(k-i+1)*alpha2);
					seq1.ycoords[k] <- S[2] + r*sin(pi/2+alpha1+(k-i+1)*alpha2);
				}
			}
			if ((x1[1] > x2[1]) && (!down)) {
				for (k in i:(i+j-1)) {
					seq1.xcoords[k] <- S[1] + r*cos(-pi/2+alpha1+(k-i+1)*alpha2);
					seq1.ycoords[k] <- S[2] + r*sin(-pi/2+alpha1+(k-i+1)*alpha2);
				}
			}
			if ((x1[1] > x2[1]) && (down)) {
				for (k in i:(i+j-1)) {
					seq1.xcoords[k] <- S[1] + r*cos(pi/2-alpha1-(k-i+1)*alpha2);
					seq1.ycoords[k] <- S[2] + r*sin(pi/2-alpha1-(k-i+1)*alpha2);
				}
			}             
		}
	}

	# creation of bonds in sequences
	bonds1 <- linesGrob(seq1.xcoords, seq1.ycoords, default.units = "npc",
	                    gp = gpar(lwd = mbonds.lwd, lty = mbonds.lty)); 
	bonds2 <- linesGrob(seq2.xcoords, seq2.ycoords, default.units = "npc",
	                    gp = gpar(lwd = mbonds.lwd, lty = mbonds.lty)); 

	# creation of Watson-Crick and Hoogsteen bonds
	WCbonds1.xcoords <- rep(NA, n.bonds);
	WCbonds1.ycoords <- rep(NA, n.bonds);
	WCbonds2.xcoords <- rep(NA, n.bonds);
	WCbonds2.ycoords <- rep(NA, n.bonds);
	for (i in 1:n.bonds) {
		WCbonds1.xcoords[i] <- seq1.xcoords[WCbonds[1,i]];
		WCbonds1.ycoords[i] <- seq1.ycoords[WCbonds[1,i]];
		WCbonds2.xcoords[i] <- seq2.xcoords[WCbonds[2,i]];
		WCbonds2.ycoords[i] <- seq2.ycoords[WCbonds[2,i]];
	} 
	bonds3 <- segmentsGrob(WCbonds1.xcoords, WCbonds1.ycoords, WCbonds2.xcoords,
	                       WCbonds2.ycoords, default.units = "npc",
	                       gp = gpar(lwd = wcbonds.lwd, lty = wcbonds.lty));

	Hbonds1.xcoords <- rep(NA, n.bonds);
	Hbonds1.ycoords <- rep(NA, n.bonds);
	Hbonds2.xcoords <- rep(NA, n.bonds);
	Hbonds2.ycoords <- rep(NA, n.bonds);
	if (dim(Hbonds1)[2] > 0) {
		for (i in 1:dim(Hbonds1)[2]) {
			Hbonds1.xcoords[i] <- seq1.xcoords[Hbonds[1,i]];
			Hbonds1.ycoords[i] <- seq1.ycoords[Hbonds[1,i]];
			Hbonds2.xcoords[i] <- seq2.xcoords[Hbonds[2,i]];
			Hbonds2.ycoords[i] <- seq2.ycoords[Hbonds[2,i]];
		} 
	}
	if (dim(Hbonds2)[2] > 0) {
		for (i in 1:dim(Hbonds2)[2]) {
			Hbonds1.xcoords[i] <- seq1.xcoords[Hbonds[1,i]];
			Hbonds1.ycoords[i] <- seq1.ycoords[Hbonds[1,i]];
			Hbonds2.xcoords[i] <- seq1.xcoords[Hbonds[2,i]];
			Hbonds2.ycoords[i] <- seq1.ycoords[Hbonds[2,i]];
		} 
	}
	bonds4 <- segmentsGrob(Hbonds1.xcoords, Hbonds1.ycoords, Hbonds2.xcoords,
	                       Hbonds2.ycoords, default.units = "npc",
	                       gp = gpar(lwd = hbonds.lwd, lty = hbonds.lty));        

	# creation of labels of nucleotides
	labels1 <- textGrob(DNAseq1.vec, seq1.xcoords, seq1.ycoords, 
	                    default.units = "npc", gp = gpar(cex = labels.cex));
	labels2 <- textGrob(DNAseq2.vec, seq2.xcoords, seq2.ycoords, 
	                    default.units = "npc", gp = gpar(cex = labels.cex));

	# creation of nucleotides  
	if (circles == TRUE) {
		color <- "black";
	} else {
		color <- "white";
	}            
	r <- (convertX(unit(get.gpar()$fontsize*labels.cex, "points"), "npc",
			valueOnly = TRUE)/2)*1.2*circles.cex;
	nucleotides1 <- circleGrob(seq1.xcoords, seq1.ycoords, rep(r, n.seq1), gp = 
	                           gpar(fill = "white", col = color));
	nucleotides2 <- circleGrob(seq2.xcoords, seq2.ycoords, rep(r, n.seq2), gp = 
	                           gpar(fill = "white", col = color));
	
	# creation of additional lines
	addlines <- segmentsGrob(c(margin+dist1/2, margin+dist1/2, margin+dist1/2), 
	                         c(0.5+dist2, 0.5, 0.5-dist2), 
	                         c(margin+dist1, margin+dist1, margin+dist1),
	                         c(0.5+dist2, 0.5, 0.5-dist2),
	                         default.units = "npc", gp = gpar(lwd = mbonds.lwd, 
	                         lty = mbonds.lty));
	# drawing
	grid.draw(dirlab);
	grid.draw(bonds1);
	grid.draw(bonds2);
	grid.draw(bonds3);
	grid.draw(bonds4);
	grid.draw(addlines);
	grid.draw(nucleotides1);
	grid.draw(nucleotides2);
	grid.draw(labels1);        
	grid.draw(labels2);
	
	return(alignment)
}

###
## 3D triplex visualization
##
## Author: Kamil Rajdl
## Date: 2012/10/28
## Package: triplex
##


###
## This function draws a 3-D model of a triplex 
##
## triplex   TriplexViews object
## opt       TRUE - structure of triplex will be optimalized
##           FALSE - structure will be drawn without optimalization
## A.col     color of Adine base
## T.col     color of Thymine base
## G.col     color of Guanine base
## C.col     color of Cytosine base
## bgr.col   color of background
## bbone.col color of backbone
## bbone.n   number of sides of backbone bonds
##
triplex.3D <- function(
	triplex,
	opt = TRUE,
	A.col = "red",
	T.col = "brown",
	G.col = "green",
	C.col = "blue",
	bbone.col = "violet",
	bgr.col = "white",
	bbone.n = 20)
{
	if ("rgl" %in% installed.packages()[,"Package"])
		library("rgl")
	else
		stop("Please install rgl package from CRAN to use this function.")
	
	# processing of inputs
	results <- triplex.input(triplex);
	triplex.type <- type(triplex);

	DNAseq1 <- results[[1]];
	DNAseq2 <- results[[2]];
	WCbonds <- results[[3]];
	Hbonds <- results[[4]];
	bends <- results[[5]];
	alignment <- results[[6]];

	bend.start <- bends[1];
	bend.end <- bends[2];   
	n.bonds <- dim(WCbonds)[2];
	n.bend <- bend.end - bend.start - 1;
	n.seq1 <- nchar(DNAseq1);
	n.seq2 <- nchar(DNAseq2);        

	# initial parameters and variables
	alpha.B <- 2.593247;
	dist.B <- 7.053836; 
	twist.B <- 36*pi/180;
	rise.B <- 3.4;
	r2 <- 0.5;               # radius of backbone

	# triplex must have length at least 2
	if (n.seq2 == 1) {
		stop("Triplex is too short, at least two triplets are necessary.");
	}

	# division of Hoogsteen bonds into DNAseq1-DNAseq1 bonds and DNAseq1-DNAseq2 bonds
	if (triplex.type %in% c("0","1","2","3")) {
		Hbonds1 <- Hbonds;
		Hbonds2 <- matrix(0,2,0);
	}
	if (triplex.type %in% c("4","5","6","7")) {
		Hbonds1 <- matrix(0,2,0);
		Hbonds2 <- Hbonds;
	}

	# processing of sequences into vector of characters
	DNAseq1.vec <- substring(DNAseq1, 1:n.seq1, 1:n.seq1);
	DNAseq2.vec <- substring(DNAseq2, 1:n.seq2, 1:n.seq2);

	# coordinates of nucleotides
	seq1.xcoords <- rep(NA, n.seq1);
	seq1.ycoords <- rep(NA, n.seq1);
	seq1.zcoords <- rep(NA, n.seq1);
	seq2.xcoords <- rep(NA, n.seq2);
	seq2.ycoords <- rep(NA, n.seq2);
	seq2.zcoords <- rep(NA, n.seq2);

	# indexes of paired nucleotides
	ind1 <- rep(NA,n.seq2);
	ind2 <- rep(NA,n.seq2);
	ind3 <- rep(NA,n.seq2);

	# names of paired nucleotides
	nuc1 <- rep(NA,n.seq2);
	nuc2 <- rep(NA,n.seq2);
	nuc3 <- rep(NA,n.seq2);

	# angles and radii in levels 
	angles1 <- rep(NA,n.seq2);
	angles2 <- rep(NA,n.seq2);
	angles3 <- rep(NA,n.seq2);
	radii <- rep(NA,n.seq2); 

	i <- 1;
	j <- n.seq1;
	if (triplex.type %in% c("0","3","5","6")) {
		n1 <- n.seq2;
		n2 <- 1;
	}
	if (triplex.type %in% c("1","2","4","7")) {
		n1 <- 1;
		n2 <- n.seq2;
	}
	p <- 0;
	for (k in n1:n2) {
		while (!(i %in% WCbonds[1,]) && !(i %in% Hbonds1[1,]) &&  !(i %in% Hbonds2)) {
			i <- i+1;
		}
		while (!(j %in% WCbonds[1,]) && !(j %in% Hbonds1[1,]) &&  !(j %in% Hbonds2)) {
			j <- j-1;
		}
		ind1[p+1] <- i;
		ind2[p+1] <- j;
		ind3[p+1] <- k;
		nuc1[p+1] <- DNAseq1.vec[i];
		nuc2[p+1] <- DNAseq1.vec[j];
		nuc3[p+1] <- DNAseq2.vec[k];

		trpl <- toTriplet(DNAseq1.vec[i], DNAseq1.vec[j], DNAseq2.vec[k], triplex.type);
		tr <- getTR(trpl, triplex.type);
		t <- tr[1];
		r <- tr[2];  
		alpha <- pi-t;              
		angles <- getAngles(alpha, triplex.type);
		a1 <- angles[1];
		a2 <- angles[2];
		a3 <- angles[3];
		angles1[p+1] <- (a1 + p*twist.B);
		angles2[p+1] <- (a2 + p*twist.B);
		angles3[p+1] <- (a3 + p*twist.B);
		radii[p+1] <- r;
		i <- i+1;
		j <- j-1;
		p <- p+1;
	}

	# optimalization
	if ((opt) && (n.bonds>2)) {
		ret <- nlm(f=toMin, p=rep(0,n.seq2-1), alpha.opt = alpha.B, dist.opt = dist.B,
					s1a = angles1, s2a = angles2, s3a = angles3, r = radii, d = rise.B);
		angles <- ret[[2]];
	} else {
		angles <- rep(0,n.seq2-1);
	}

	r <- radii[1];
	seq1.xcoords[ind1[1]] <- r*cos(angles1[1]);
	seq1.ycoords[ind1[1]] <- r*sin(angles1[1]);
	seq1.zcoords[ind1[1]] <- 0;
	seq1.xcoords[ind2[1]] <- r*cos(angles2[1]);
	seq1.ycoords[ind2[1]] <- r*sin(angles2[1]);
	seq1.zcoords[ind2[1]] <- 0;
	seq2.xcoords[ind3[1]] <- r*cos(angles3[1]);
	seq2.ycoords[ind3[1]] <- r*sin(angles3[1]);
	seq2.zcoords[ind3[1]] <- 0;

	if (n.seq2 > 1) {
	for (p in 2:n.seq2) {
		i <- ind1[p];
		j <- ind2[p];
		k <- ind3[p];
		r <- radii[p];
		seq1.xcoords[i] <- r*cos(angles1[p] + angles[p-1]);
		seq1.ycoords[i] <- r*sin(angles1[p] + angles[p-1]);
		seq1.zcoords[i] <- (p-1)*rise.B;
		seq1.xcoords[j] <- r*cos(angles2[p] + angles[p-1]);
		seq1.ycoords[j] <- r*sin(angles2[p] + angles[p-1]);
		seq1.zcoords[j] <- (p-1)*rise.B;
		seq2.xcoords[k] <- r*cos(angles3[p] + angles[p-1]);
		seq2.ycoords[k] <- r*sin(angles3[p] + angles[p-1]);
		seq2.zcoords[k] <- (p-1)*rise.B;
	}                
	} 

	# coordinates of nucleotiodes in the bend
	if ((bend.end-bend.start)>1) {
		x1 <- c(seq1.xcoords[bend.start], seq1.ycoords[bend.start], seq1.zcoords[bend.start]);
		j <- 1;
		while (is.na(seq1.xcoords[bend.start-j])) {
			j <- j+1;
		}
		x2 <- c(seq1.xcoords[bend.start-j], seq1.ycoords[bend.start-j], seq1.zcoords[bend.start-j]);
		y1 <- c(seq1.xcoords[bend.end], seq1.ycoords[bend.end], seq1.zcoords[bend.end]);
		j <- 1;
		while (is.na(seq1.xcoords[bend.end+j])) {
			j <- j+1;  
		}
		y2 <- c(seq1.xcoords[bend.end+j], seq1.ycoords[bend.end+j], seq1.zcoords[bend.end+j]);
		m <- bend.end-bend.start-1; 
		coords <- countBend(x1,x2,y1,y2,dist.B,m);
		xcoords <- coords[[1]]; 
		ycoords <- coords[[2]]; 
		zcoords <- coords[[3]]; 
		
		for (i in 1:m) {
			seq1.xcoords[bend.start+i] <- xcoords[i];
			seq1.ycoords[bend.start+i] <- ycoords[i];
			seq1.zcoords[bend.start+i] <- zcoords[i];
		}
	}

	# coordinates of nucleotides opposite the gaps
	for (i in 1:n.seq1) {
		if (is.na(seq1.xcoords[i])) {
			j<-1
			while (is.na(seq1.xcoords[i+j])) {
				j<-j+1;
			}
			x1 <- c(seq1.xcoords[i-1], seq1.ycoords[i-1], seq1.zcoords[i-1]);
			y1 <- c(seq1.xcoords[i+j], seq1.ycoords[i+j], seq1.zcoords[i+j]);
			x2 <- c(0,0,x1[3]);
			y2 <- c(0,0,y1[3]);
			coords <- countBend(x1,x2,y1,y2,dist.B,j);
			xcoords <- coords[[1]]; 
			ycoords <- coords[[2]]; 
			zcoords <- coords[[3]]; 
			for (k in 1:j) {
				seq1.xcoords[i+k-1] <- xcoords[k];
				seq1.ycoords[i+k-1] <- ycoords[k];
				seq1.zcoords[i+k-1] <- zcoords[k];
			}                
		}
	}

	# coordinates of Watson-Crick and Hoogsteen bonds
	WCbonds1.xcoords <- rep(NA, n.bonds);
	WCbonds1.ycoords <- rep(NA, n.bonds);
	WCbonds1.zcoords <- rep(NA, n.bonds);
	WCbonds2.xcoords <- rep(NA, n.bonds);
	WCbonds2.ycoords <- rep(NA, n.bonds);
	WCbonds2.zcoords <- rep(NA, n.bonds);
	for (i in 1:n.bonds) {
		WCbonds1.xcoords[i] <- seq1.xcoords[WCbonds[1,i]];
		WCbonds1.ycoords[i] <- seq1.ycoords[WCbonds[1,i]];
		WCbonds1.zcoords[i] <- seq1.zcoords[WCbonds[1,i]];
		WCbonds2.xcoords[i] <- seq2.xcoords[WCbonds[2,i]];
		WCbonds2.ycoords[i] <- seq2.ycoords[WCbonds[2,i]];
		WCbonds2.zcoords[i] <- seq2.zcoords[WCbonds[2,i]];
	}


	Hbonds1.xcoords <- rep(NA, n.bonds);
	Hbonds1.ycoords <- rep(NA, n.bonds);
	Hbonds1.zcoords <- rep(NA, n.bonds);
	Hbonds2.xcoords <- rep(NA, n.bonds);
	Hbonds2.ycoords <- rep(NA, n.bonds);
	Hbonds2.zcoords <- rep(NA, n.bonds);
	if (dim(Hbonds1)[2] > 0) {
		for (i in 1:dim(Hbonds1)[2]) {
			Hbonds1.xcoords[i] <- seq1.xcoords[Hbonds[1,i]];
			Hbonds1.ycoords[i] <- seq1.ycoords[Hbonds[1,i]];
			Hbonds1.zcoords[i] <- seq1.zcoords[Hbonds[1,i]];
			Hbonds2.xcoords[i] <- seq2.xcoords[Hbonds[2,i]];
			Hbonds2.ycoords[i] <- seq2.ycoords[Hbonds[2,i]];
			Hbonds2.zcoords[i] <- seq2.zcoords[Hbonds[2,i]];
		} 
	}
	if (dim(Hbonds2)[2] > 0) {
		for (i in 1:dim(Hbonds2)[2]) {
			Hbonds1.xcoords[i] <- seq1.xcoords[Hbonds[1,i]];
			Hbonds1.ycoords[i] <- seq1.ycoords[Hbonds[1,i]];
			Hbonds1.zcoords[i] <- seq1.zcoords[Hbonds[1,i]];
			Hbonds2.xcoords[i] <- seq1.xcoords[Hbonds[2,i]];
			Hbonds2.ycoords[i] <- seq1.ycoords[Hbonds[2,i]];
			Hbonds2.zcoords[i] <- seq1.zcoords[Hbonds[2,i]];
		} 
	}

	# drawing
	rgl.bg(color = bgr.col);
	rgl.spheres(seq1.xcoords, seq1.ycoords, seq1.zcoords, rep(r2, n.seq1), col = bbone.col);
	rgl.spheres(seq2.xcoords, seq2.ycoords, seq2.zcoords, rep(r2, n.seq2), col = bbone.col);

	for (i in 1:(n.seq1-1)) {
		x <- c(seq1.xcoords[i], seq1.ycoords[i], seq1.zcoords[i]);
		y <- c(seq1.xcoords[i+1], seq1.ycoords[i+1], seq1.zcoords[i+1]);
		join(x,y,r2,bbone.col, bbone.n);
	}

	for (i in 1:(n.seq2-1)) {
		x <- c(seq2.xcoords[i], seq2.ycoords[i], seq2.zcoords[i]);
		y <- c(seq2.xcoords[i+1], seq2.ycoords[i+1], seq2.zcoords[i+1]);
		join(x,y,r2,bbone.col, bbone.n);
	}

	for (i in 1:n.bonds) {
	x1 <- c(WCbonds1.xcoords[i], WCbonds1.ycoords[i], WCbonds1.zcoords[i]);
	x2 <- c(WCbonds2.xcoords[i], WCbonds2.ycoords[i], WCbonds2.zcoords[i]);
	y1 <- c(Hbonds1.xcoords[i], Hbonds1.ycoords[i], Hbonds1.zcoords[i]);
	y2 <- c(Hbonds2.xcoords[i], Hbonds2.ycoords[i], Hbonds2.zcoords[i]);
	if (sum(abs(x1-y1)) < 10^(-3)) {
		x <- x2;
		y <- x1;
		z <- y2;
	}
	if (sum(abs(x2-y1)) < 10^(-3)) {
		x <- x1;
		y <- x2;
		z <- y2;
	} 
	if (sum(abs(x1-y2)) < 10^(-3)) {
		x <- x2;
		y <- x1;
		z <- y1;
	} 
	if (sum(abs(x2-y2)) < 10^(-3)) {
		x <- x1;
		y <- x2;
		z <- y1;
	}

	trpl <- toTriplet(nuc1[i], nuc2[i], nuc3[i], triplex.type);
	trpl <- substring(trpl, 1:3, 1:3);
	drawBonds(x, y, z, trpl[3], trpl[2], trpl[1], bbone.col, A.col, T.col, G.col, C.col);
	}
	return(alignment)
}


###
## Auxialiary functions
##

getColor <- function(nucleotide, A.col, T.col, G.col, C.col)
{
	color <- "black";
	if (nucleotide == "A") {
		color <- A.col;
	}
	if (nucleotide == "T") {
		color <- T.col;
	}
	if (nucleotide == "G") {
		color <- G.col;
	} 
	if (nucleotide == "C") {
		color <- C.col;
	}
	return(color);
}

join <- function(x,y,r,color,bbone.n)
{
	u <- x-y;
	a <- u[1];
	b <- u[2];
	cc <- u[3];
	if (abs(a) < 10^(-8)) {
		if (abs(b) < 10^(-8)) {
			v1 <- c(1,0,0);
			v2 <- c(0,1,0);
		} else {
			v1 <- c(1,0,0);
			v2 <- c(0,cc,-b);
		}
	} else {
		v1 <- c(b,-a,0);
		if ((abs(b) < 10^(-8)) || (abs(cc) < 10^(-8))) {
			v2 <- c(cc, 0, -a);
		} else {
			v2 <- c(b-(b^2+a^2)/b, -a, a*(b^2+a^2)/(b*cc));
		}   
	}
	v1 <- v1*r/sqrt(sum(v1*v1));
	v2 <- v2*r/sqrt(sum(v2*v2));
	n <- bbone.n;
	alpha <- 2*pi/n;
	for (i in 1:n) {
		p1 <- x + v1*cos((i-1)*alpha) + v2*sin((i-1)*alpha); 
		p2 <- x + v1*cos(i*alpha) + v2*sin(i*alpha);
		p3 <- y + v1*cos((i-1)*alpha) + v2*sin((i-1)*alpha); 
		p4 <- y + v1*cos(i*alpha) + v2*sin(i*alpha);
		rgl.quads(c(p1[1],p2[1],p4[1],p3[1]), c(p1[2],p2[2],p4[2],p3[2]), c(p1[3],p2[3],p4[3],p3[3]), col = color);
	}
}

getTR <- function(S, triplex.type)
{
	r = 10;
	t = 80;
	found = FALSE;
	if (triplex.type %in% c("4","5","6","7")) {
		if (S == "AAT") {
			r = 7.409632;
			t = 76.5364;
			found = TRUE;
		}
		if (S == "AGC") {
			r = 11.9128;
			t = 125.6857;
			found = TRUE;
		}
		if (S == "CAT") {
			r = 5.563016;
			t = 72.08654;
			found = TRUE;
		}
		if (S == "GGC") {
			r = 7.961633;
			t = 94.1352;
			found = TRUE;
		}
		if (S == "TAT") {
			r = 6.379035;
			t = 72.20278;
			found = TRUE;
		}
		if (S == "TCG") {
			r = 7.441224;
			t = 93.85905;
			found = TRUE;
		}
	}
	if (triplex.type %in% c("0","1","2","3")) {
		if (S == "CGC") {
			r = 8.897408;
			t = 108.8662;
			found = TRUE;
		}
		if (S == "GGC") {
			r = 7.161497;
			t = 74.82808;
			found = TRUE;
		}
		if (S == "GTA") {
			r = 12.28118;
			t = 125.5032;
			found = TRUE;
		}
		if (S == "TAT") {
			r = 7.896785;
			t = 103.7168;
			found = TRUE;
		}
		if (S == "TCG") {
			r = 6.469698;
			t = 70.47479;
			found = TRUE;
		}
		if (S == "TGC") {
			r = 6.630192;
			t = 77.89392;
			found = TRUE;
		}
	}
	if (!found) {
		warning("Triplex contains unknown triplet (its parameters were set to default).");
	}
	t = (t/180)*pi;
	return(c(t,r));
}

toTriplet <- function(nuc1, nuc2, nuc3, triplex.type)
{
	triplet <- paste(nuc1,nuc2,nuc3,sep="");
	if (triplex.type %in% c("0","3")) {
		triplet <- paste(nuc2,nuc3,nuc1,sep="");
	}
	if (triplex.type %in% c("1","2")) {
		triplet <- paste(nuc1,nuc3,nuc2,sep="");
	}
	if (triplex.type %in% c("4","7")) {
		triplet <- paste(nuc1,nuc2,nuc3,sep="");
	}
	if (triplex.type %in% c("5","6")) {
		triplet <- paste(nuc2,nuc1,nuc3,sep="");
	}
	return(triplet); 
}                                                                           

getAngles <- function(alpha, triplex.type)
{
	a1 <- 0;
	a2 <- 2*alpha;
	a3 <- alpha;
	
	if (triplex.type %in% c("0","3")) {
		a1 <- 0;
		a2 <- 2*alpha;
		a3 <- alpha;
	}
	if (triplex.type %in% c("1","2")) {
		a1 <- 2*alpha;
		a2 <- 0;
		a3 <- alpha;
	}
	if (triplex.type %in% c("4","7")) {
		a1 <- 2*alpha;
		a2 <- alpha;
		a3 <- 0;
	}
	if (triplex.type %in% c("5","6")) {
		a1 <- alpha;
		a2 <- 0;
		a3 <- 2*alpha;
	} 
	return(c(a1,a2,a3));
}

countBend <- function(x1,x2,y1,y2,bend.dist,m)
{
	xcoords <- rep(NA,m);
	ycoords <- rep(NA,m);
	zcoords <- rep(NA,m);   
	d1 <- sqrt(sum((x1-y1)^2));
	d2 <- bend.dist;
	z1 <- (x1+y1)/2;
	z2 <- (x2+y2)/2;                                         
	u <- y1-x1;
	v <- z1-z2;
	w <- c(u[2]*v[3]-u[3]*v[2],u[3]*v[1]-u[1]*v[3],u[1]*v[2]-u[2]*v[1]);
	direc <- c(w[2]*u[3]-w[3]*u[2],w[3]*u[1]-w[1]*u[3],w[1]*u[2]-w[2]*u[1]); 
		
	if ((m+1)*d2 <= d1) {                                # just line
		base1 <- u/(m+1);
		for (i in 1:m) {
			point <- x1 + base1*i;
			xcoords[i] <- point[1];
			ycoords[i] <- point[2];
			zcoords[i] <- point[3];
		}
	} else {     # circle

		if (d2 < d1*sin(pi/(2*(m+1)))) {                   # smaller than half circle
			r <- optimize(function(r) (2*r*sin((asin(d1/(2*r)))/(m+1))-d2)^2, 
											lower=d1/2, upper=(m+1)*d2)[[1]];
			S <- z1 - (direc/sqrt(sum(direc^2)))*sqrt(r^2-(d1^2)/4);
			base1 <- x1 - S;
			vv <- y1 - S;
			base2 <- base1 - (sum(base1*base1)/sum(base1*vv))*vv;
			if (sum(base1*vv) > 0) {
				base2 <- -base2*r/sqrt(sum(base2^2));
				} else {
				base2 <- base2*r/sqrt(sum(base2^2));
			}
			betta <- (2*asin(d1/(2*r)))/(m+1);
				
		} else if (d2 > d1*sin(pi/(2*(m+1)))) {             # bigger than half circle
			r <- optimize(function(r) (2*r*sin((pi-asin(d1/(2*r)))/(m+1))-d2)^2, 
											lower=d1/2, upper=(m+1)*d2)[[1]];
			S <- z1 + (direc/sqrt(sum(direc^2)))*sqrt(r^2-(d1^2)/4);
			base1 <- x1 - S;
			vv <- y1 - S;
			base2 <- base1 - (sum(base1*base1)/sum(base1*vv))*vv;
			if (sum(base1*vv) > 0) {
				base2 <- base2*r/sqrt(sum(base2^2));
				} else {
				base2 <- -base2*r/sqrt(sum(base2^2));
			}
			betta <- (2*pi - 2*asin(d1/(2*r)))/(m+1);
				
		} else {                                             # half circle
			r <- d1/2;
			S <- z1;
			base1 <- x1 - S;
			base2 <- (direc/sqrt(sum(direc^2)))*d1/2;
			betta <- pi/(m+1);
		}
			
		
		for (i in 1:m) {
			point <- S + base1*cos(i*betta)+base2*sin(i*betta);
			xcoords[i] <- point[1];
			ycoords[i] <- point[2];
			zcoords[i] <- point[3];    
		}
	}
	coords <- list(xcoords,ycoords,zcoords);
	return(coords);
}

drawBonds <- function(x, y, z, nuc1, nuc2, nuc3, bbone.col, A.col, T.col, G.col, C.col)
{
	S <- (x+y+z)/3;
	u <- S-x;
	v <- S-y;
	w <- S-z;    
	u <- (u/sqrt(sum(u^2)))*2.5;
	v <- (v/sqrt(sum(v^2)))*2.5;  
	w <- (w/sqrt(sum(w^2)))*2.5;
	joinRect(x, x+u, 0.2, bbone.col);
	joinRect(y, y+v, 0.2, bbone.col);
	joinRect(z, z+w, 0.2, bbone.col);
	drawBase(x, x+u, nuc1, A.col, T.col, G.col, C.col);
	drawBase(y, y+v, nuc2, A.col, T.col, G.col, C.col); 
	drawBase(z, z+w, nuc3, A.col, T.col, G.col, C.col);  
}

joinRect <- function(x,y,d,color)
{
	u <- y-x;
	v <- c(u[2],-u[1],0);
	v <- (v/sqrt(sum(v^2)))*(d/2);
	p1 <- x+v;
	p2 <- x-v;
	p3 <- y+v;
	p4 <- y-v;   
	rgl.quads(c(p1[1],p2[1],p4[1],p3[1]), c(p1[2],p2[2],p4[2],p3[2]), c(p1[3],p2[3],p4[3],p3[3]), col = color);
}

drawBase <- function(x,y,nuc, A.col, T.col, G.col, C.col)
{
	color = getColor(nuc, A.col, T.col, G.col, C.col);

	if (nuc %in% c("C","T")) {
		r <- 1.2;
		u <- y-x;
		S <- y + (u/sqrt(sum(u^2)))*r;
		base1 <- y-S;
		base2 <- c(base1[2],-base1[1],0); 
		xcoords <- c(NA,NA,S[1]);
		ycoords <- c(NA,NA,S[2]);
		zcoords <- c(NA,NA,S[3]);
		for (i in 1:6) {
			point1 <- S + base1*cos((i-1)*(pi/3))+base2*sin((i-1)*(pi/3));
			xcoords[1] <- point1[1];
			ycoords[1] <- point1[2];
			zcoords[1] <- point1[3];
			point2 <- S + base1*cos(i*(pi/3))+base2*sin(i*(pi/3));
			xcoords[2] <- point2[1];
			ycoords[2] <- point2[2];
			zcoords[2] <- point2[3];
			rgl.triangles(xcoords, ycoords, zcoords, col = color);    
		}
	}
	if (nuc %in% c("A","G")) {
		r <- 0.85*1.2;
		u <- y-x;
		S <- y + (u/sqrt(sum(u^2)))*r;
		base1 <- y-S;
		base2 <- c(base1[2],-base1[1],0); 
		if ((base1[1]*base2[2]-base1[2]*base2[1])<0) {
			base2 <- -base2;
		}
		xcoords <- c(NA,NA,S[1]);
		ycoords <- c(NA,NA,S[2]);
		zcoords <- c(NA,NA,S[3]);
		for (i in 1:5) {
			point1 <- S + base1*cos((i-1)*(2*pi/5)+4*pi/5)+base2*sin((i-1)*(2*pi/5)+4*pi/5);
			xcoords[1] <- point1[1];
			ycoords[1] <- point1[2];
			zcoords[1] <- point1[3];
			point2 <- S + base1*cos(i*(2*pi/5)+4*pi/5)+base2*sin(i*(2*pi/5)+4*pi/5);
			xcoords[2] <- point2[1];
			ycoords[2] <- point2[2];
			zcoords[2] <- point2[3];
			rgl.triangles(xcoords, ycoords, zcoords, col = color);    
		}
		r <- sqrt(sum((point1-point2)^2));
		z <- (point1+point2)/2;
		v <- z-S;
		v <- (v/sqrt(sum(v^2)))*(sqrt(3)*r/2);
		S <- z+v;
		base1 <- point1-S;
		base2 <- c(base1[2],-base1[1],0); 
		for (i in 1:6) {
			point1 <- S + base1*cos((i-1)*(pi/3))+base2*sin((i-1)*(pi/3));
			xcoords[1] <- point1[1];
			ycoords[1] <- point1[2];
			zcoords[1] <- point1[3];
			point2 <- S + base1*cos(i*(pi/3))+base2*sin(i*(pi/3));
			xcoords[2] <- point2[1];
			ycoords[2] <- point2[2];
			zcoords[2] <- point2[3];
			rgl.triangles(xcoords, ycoords, zcoords, col = color);    
		}
	}
}

toMin <- function(alpha, alpha.opt, dist.opt, s1a, s2a, s3a, r, d)
{
	n <- length(r);
	S <- 0;
	x1 <- c(r[1]*cos(s1a[1]), r[1]*sin(s1a[1]),-d);
	x2 <- c(r[2]*cos(s1a[2]+alpha[1]), r[2]*sin(s1a[2]+alpha[1]),0);
	x3 <- c(r[3]*cos(s1a[3]+alpha[2]), r[3]*sin(s1a[3]+alpha[2]),d);
	u <- x1-x2;
	v <- x3-x2;
	alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
	S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2; 
	
	x1 <- c(r[1]*cos(s2a[1]), r[1]*sin(s2a[1]),-d);
	x2 <- c(r[2]*cos(s2a[2]+alpha[1]), r[2]*sin(s2a[2]+alpha[1]),0);
	x3 <- c(r[3]*cos(s2a[3]+alpha[2]), r[3]*sin(s2a[3]+alpha[2]),d);
	u <- x1-x2;
	v <- x3-x2;
	alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
	S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2; 
		
	x1 <- c(r[1]*cos(s3a[1]), r[1]*sin(s3a[1]),-d);
	x2 <- c(r[2]*cos(s3a[2]+alpha[1]), r[2]*sin(s3a[2]+alpha[1]),0);
	x3 <- c(r[3]*cos(s3a[3]+alpha[2]), r[3]*sin(s3a[3]+alpha[2]),d);
	u <- x1-x2;
	v <- x3-x2;
	alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
	S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2; 

	if (n>3) {
	for (i in 3:(n-1)) {
		x1 <- c(r[i-1]*cos(s1a[i-1]+alpha[i-2]), r[i-1]*sin(s1a[i-1]+alpha[i-2]),-d);
		x2 <- c(r[i]*cos(s1a[i]+alpha[i-1]), r[i]*sin(s1a[i]+alpha[i-1]),0);
		x3 <- c(r[i+1]*cos(s1a[i+1]+alpha[i]), r[i+1]*sin(s1a[i+1]+alpha[i]),d);
		u <- x1-x2;
		v <- x3-x2;
		alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
		S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2; 
		
		x1 <- c(r[i-1]*cos(s2a[i-1]+alpha[i-2]), r[i-1]*sin(s2a[i-1]+alpha[i-2]),-d);
		x2 <- c(r[i]*cos(s2a[i]+alpha[i-1]), r[i]*sin(s2a[i]+alpha[i-1]),0);
		x3 <- c(r[i+1]*cos(s2a[i+1]+alpha[i]), r[i+1]*sin(s2a[i+1]+alpha[i]),d);
		u <- x1-x2;
		v <- x3-x2;
		alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
		S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2;  
		
		x1 <- c(r[i-1]*cos(s3a[i-1]+alpha[i-2]), r[i-1]*sin(s3a[i-1]+alpha[i-2]),-d);
		x2 <- c(r[i]*cos(s3a[i]+alpha[i-1]), r[i]*sin(s3a[i]+alpha[i-1]),0);
		x3 <- c(r[i+1]*cos(s3a[i+1]+alpha[i]), r[i+1]*sin(s3a[i+1]+alpha[i]),d);
		u <- x1-x2;
		v <- x3-x2;
		alpha.old <- acos(sum(u*v)/(sqrt(sum(u^2))*sqrt(sum(v^2))));
		S <- S+((alpha.old-alpha.opt)/(alpha.opt))^2 + ((sqrt(sum(u^2))-dist.opt)/(dist.opt))^2; 
	}
	}
	return(S);
}

%\VignetteIndexEntry{Triplex User Guide}
%\VignetteKeywords{Triplex, DNA, Sequence, Biostrings} 
%\VignettePackage{triplex}

\documentclass[a4paper]{article}
\usepackage[utf8]{inputenc}

\title{Triplex: User Guide}
\author{Matej Lexa, Tom\'{a}\v{s} Mart\'{i}nek, Ji\v{r}\'{i} Hon}


\begin{document}
\SweaveOpts{concordance=TRUE}

\maketitle

\tableofcontents

\section{Introduction}

The R triplex package is essentially an R interface to the underlying C
implementation of a dynamic-programming search strategy of the same name
published in~\cite{Lexa2011}. The main functionality of the original program
is to detect positions of subsequences in a much larger sequence, where these
subsequences are
likely to fold into an intramolecular triplex (H-DNA). The evaluation is
based on the number of canonical nucleotide triplets that can form from
nucleotides in such subsequence .  In
creating this incarnation in R, we extended the basic functionality, to also
include the calculation of likely base-pairing in the triple helices. This
allowed us to extend the functionality of the package towards visualization
showing the exact base-pairing in 2D or 3D as published
earlier~\cite{Rajdl12}.

The rest of this vignette is organized as follows: The basic usage of the
package for triplex detection is described in section~\ref{sec:detection}.
Two methods for visualization of detected triplexes in 2D and 3D are shown in
section~\ref{sec:visualization}. Section~\ref{sec:export} describes
techniques for the conversion of search results into other types of objects
such as {\it GRanges} or {\it DNAStringSet}, that can be further exported
into GFF3 or FASTA files. The vignette is concluded with
section~\ref{sec:real} showing triplex package usage on a real genomic
sequence from {\it BSGenome}. 


\newpage

\section{Detection}
\label{sec:detection}

As usual, before first package use, it is necessary to load the triplex 
library using the following command:

<<>>=
library(triplex)
@

Identification of potential intramolecular triplex-forming sequences in DNA
is performed using the {\it triplex.search} function.  This function has one
required parameter representing the studied DNA sequence in the form of a
{\it DNAString} object and several modifying options with predefined values
(see {\it triplex.search} help page).

Based on triplex position (forward or reverse strand) and its third strand
orientation, up to 8 types of triplexes are distinguished by the {\it triplex.search} function. All
these triplex types are depicted on figure~\ref{fig:types}. By default, the
function detects all 8 types, however this behaviour can be changed by
setting {\it type} parameter to arbitrary value or a subset of values in the 
range 0 to 7.

\begin{figure}[h]
\centering
   \includegraphics[width=.8\linewidth]{fig/types.pdf}
   \caption{Triplex types}
   \label{fig:types}
\end{figure}

\subsection*{Example 1: Basic triplex detection}

As a simple example, let's find all types of intramolecular triplexes in the DNA
sequence {\it TTGGGGAAAGCAATGCCAGGCAGGGGGTTCCTTTCGTTACGGTCCGTCCC}:

<<>>=
seq <- DNAString("TTGGGGAAAGCAATGCCAGGCAGGGGGTTCCTTTCGTTACGGTCCGTCCC")
triplex.search(seq)
@

Detected triplexes are returned in the form of a {\it TriplexViews} class,
which represents the basic container for storing a set of views on the same
input sequence similarly to {\it XStringView} object (in fact {\it
TriplexViews} only extends the {\it XStringView} class with the number of
displayed columns). Each triplex view is defined by start locations, width,
score, P-value, number of insertions, type, strand, loop start position and
loop end position. 

Please note, that the strand orientation depends on triplex type only. The
{\it triplex.search} function assumes that input DNA sequence represents
the forward strand.

\subsection*{Example 2: Selection of a specific triplex type}

Let's reduce the searching procedure to triplex type 1 only, using the
following command. Please note, that the output list contains potential
triplexes of type 1 only.

<<>>=
triplex.search(seq, type=1)
@


The basic requirements for shape or length of detected triplexes can be
defined using four parameters: {\it min\_len}, {\it max\_len}, {\it
min\_loop} and {\it max\_loop}. While {\it min\_len} and {\it max\_len}
specify the length of triplex stems composed of individual triplets, {\it
min\_loop} and {\it max\_loop} parameters define the range of lengths for
unpaired loops at the top of detected triplexes.  A graphical representation
of these parameters is shown in figure~\ref{fig:triplex}.  Please note that
these parameters also impacts the overall computation time. For longer
triplexes, larger space has to be explored and thus more computation time is
consumed.

\begin{figure}[h]
\centering
   \includegraphics[width=.6\linewidth]{fig/triplex.pdf}
   \caption{Triplex scheme}
   \label{fig:triplex}
\end{figure}

\subsection*{Example 3: Definition of triplex shape}

Let's modify the previous example by specifying minimal and maximal triplex
lengths. Please, execute the following command and note that only one of the 
two triplexes detected before satisfies these conditions.

<<>>=
triplex.search(seq, min_len=10, max_len=20)
@

The quality of each triplex is defined by its score value. A higher score
value represents a higher-quality triplex. This quality is decreased by
several types of imperfections at the level of triplets, such as character
(nucleotide) mismatch, insertion, deletion, isomorphic group change etc.
Penalization constants for these imperfections can be set up using the
following parameters: {\it mis\_pen}, {\it ins\_pen}, {\it iso\_pen}, {\it
iso\_bonus} and {\it dtwist\_pen}. Detailed information
about the scoring function and penalization parameters can be found
in~\cite{Lexa2011}. It is highly recommended to see~\cite{Lexa2011} prior to
changing any penalization parameter.

\subsection*{Example 4: Scoring function modification}

Let's modify the previous example by reducing the penalization for 
isomorphic group change from value 5 to 2. Please execute the following 
command and note that calculated score values have changed.

<<>>=
triplex.search(seq, iso_pen=2)
@


The {\it triplex.search} function can result in a large list containing tens
of thousands of potential triplexes. The size of these results can be reduced
using two filtration mechanisms: (1) by specifying the minimal acceptable
score value using {\it min\_score} parameter or (2) by specifying maximum
acceptable P-value of results using {\it p\_value} parameter. The P-value
represents the probability of occurrence of detected triplexes in a random
sequence. % By default, only triplexes with P-value equal or less than 0.05 are reported.
Calculation of P-value depends on two extreme value
distribution parameters {\it lambda} and {\it mi}. It is highly recommended
to see~\cite{Lexa2011} prior changing the {\it lambda} or {\it mi}
parameters.

\subsection*{Example 5: Filtration of results}

Let's modify the previous example to show only triplexes with score values 14
or higher.  Please execute the following command and note that only one of
the two previously detected triplexes satisfies this condition.

<<>>=
triplex.search(seq, min_score=14)
@

\newpage

\section{Visualization}
\label{sec:visualization}

Besides triplex detection, the {\it triplex} package offers also
visualization of detected results. Three major methods of visualization are
supported:

\begin{enumerate}

   \item {\it Triplex alignment (text)}: Selected triplex is shown in basic
   text format representing the alignment of all of its strands. The output
   consists of four sequences: {\it plus} and {\it minus} sequences
   representing 5' to 3' and 3' to 5' DNA strands of the detected triplex; {\it
   anti/para-plus/minus} sequence representing the third triplex strand
   aligned to {\it plus} or {\it minus} strand in {\it antiparallel} or {\it
   parallel} fashion; and finally {\it loop} sequence representing the unpaired
   loop.  Please, note that all eight triplex types shown in
   figure~\ref{fig:types} can be represented using four types of alignments,
   because each alignment can correspond to triplex detected either on forward
   or reverse DNA strand.

   \item {\it 2D diagram (graphical)}: Selected triplex is shown in a 2D diagram
   displaying the individual triplets (based on Watson-Crick and Hoogsteen
   base paring) and the loop composed of unpaired nucleotides. 

   \item {\it 3D model (graphical)}: Selected triplex is shown in 3D. At first, a model is
   calculated and then the result is displayed using the {\it RGL} package, 
   which allows you to manipulate the triplex 3D model (zoom in, zoom out, 
   rotation, etc.).

\end{enumerate}

\subsection*{Example 6: Triplex visualization}

Let's suppose, we would like to display an alignment (in text format),
a 2D diagram and a 3D model of the best detected triplex from the previous
examples.  At first, it is suitable to store the results of calling the {\it
triplex.search} function into an auxiliary variable.

<<>>=
t <- triplex.search(seq)
t
@

Then, call {\it triplex.alignment} function on the first item of the list.
Please note that similarly to other DNA multiple sequence alignments the
output of the {\it triplex.alignment} method is stored as {\it DNAStringSet}
object. Also note that the {\it loop} sequence is always the last one and
unaligned to the previous three sequences.

<<>>=
triplex.alignment(t[1])
@

Then, call {\it triplex.diagram} function on the same item of the list.
Please note that at first the triplex alignment is calculated and printed into
R console and then the graphical output is displayed in a separate window. R
provides methods to redirect the output to other suitable devices, such as
files (see {\it png()}, for example).


\setkeys{Gin}{width=.6\linewidth}
\begin{figure}[h]
\centering
<<fig=TRUE>>=
triplex.diagram(t[1])
@
   \caption{2D diagram of a detected triplex}
   \label{fig:triplexvis2d}
\end{figure}

\newpage

Finally, let's display the 3D structure of the same triplex using {\it
triplex.3D} function. Please note that the result will be displayed in
separate graphical window using the {\it RGL} library. The 3D model is based 
on optimizing angles and distances present in the molecule to be as close as 
possible to tabulated values (see \cite{Rajdl12} for more information).  

<<eval=FALSE>>=
triplex.3D(t[1])
@

<<echo=FALSE>>=
triplex.alignment(t[1])
@

\begin{figure}[h!]
\centering
   \includegraphics[width=.6\linewidth]{fig/triplex3d}
   \caption{3D scheme of detected triplex}
   \label{fig:triplexvis3d}
\end{figure}

\newpage

\section{Exporting Results}
\label{sec:export}

As mentioned above, the results of detection are stored in the {\it TriplexView}
object. Because the {\it TriplexView} class is only an extension of the {\it
XStringViews} class, all operations applied to the {\it XStringViews} object 
can also be applied to the {\it TriplexView} object as well.

Additionaly, {\it TriplexView} class contains a conversion function to create 
{\it GRanges} objects. Thus, all detected triplexes can be transformed
into elements of a {\it GRanges} object and saved as a GFF3 file, for example.

\subsection*{Example 7: GRanges conversion}

In this example, the output of the {\it triplex.search} function will be stored
in a {\it GRanges} object and further exported as a GFF3 file. At first,
let's do the conversion using the following command:

<<>>=
gr <- as(t, "GRanges")
gr
@

Please note that the chromosome name is set to {\it chr1} by default, but it
can be changed to any other value.  Items such as score, triplex
type, P-value, loop start position, loop end position and number of indels
can be added as optional attributes. In the next step the resulting 
{\it GRanges} object is exported as a GFF3 file. 

<<>>=
library(rtracklayer)
export(gr,"test.gff", version="3")
@

Please note, that it is necessary to load the {\it rtracklayer} library before
running the {\it export} command. The contents of the resulting GFF3 file are:

<<echo=FALSE>>=
text <- readLines("test.gff",n=10)
cat(strwrap(text, width=80, exdent=3),sep="\n")
@

Another possibility of utilizing the results of detection is to transform the 
{\it TriplexView} object into a {\it DNAStringSet} object, which represents 
another commonly used class of the {\it Biostrings} package. Triplexes stored 
inside {\it DNAStringSet} can be exported into a FASTA file, for example.

\subsection*{Example 8: DNAStringSet conversion}

In this example, the output of the {\it triplex.search} function will be stored
into a {\it DNAStringSet} object and further exported as a FASTA file. At
first, let's do the conversion using the following command:

<<>>=
dss <- as(t, "DNAStringSet")
dss
@

\noindent In the next step, the {\it DNAStringSet} object is exported as a FASTA file.

<<>>=
writeXStringSet(dss, file="test.fa", format="fasta")
@

\noindent The contents of the resulting FASTA file are:

<<echo=FALSE>>=
text <- readLines("test.fa",n=10)
cat(text,sep="\n")
@

Please, note that all attributes of detection such as start position, end
position, score value, P-value, number of indels, triplex type and strand
are stored as a {\it name} parameter (inside the {\it DNAStringSet}), and thus,
they are also shown in the description line of the FASTA format (the line 
with the initial '>' symbol). 


\newpage

\section{A real world example}
\label{sec:real}

In the following example, we load a real genomic sequence from one of the
BSGenome packages, identify potential triplexes with length over 8 triplets
of nucleotides and less than 15\% mismatches (score >17 with the currently
used scoring matrices), create three different visualizations of the best
triplexes. We export the identified positions into a genome annotation track
(via a GFF3 file) and FASTA file. Finally, we plot some statistics about the
potential triplex distribution and nucleotide composition.

\begin{enumerate}

\item Load necessary libraries and genomes.

<<>>=
library(triplex) 
library(BSgenome.Celegans.UCSC.ce10) 
@
\item Search for potential triplex positions and display the results. Please
note that the sequence is limited to the first 100k bases for time reasons.

<<>>=
t <- triplex.search(Celegans[["chrX"]][1:100000],min_score=17,min_len=8)
t
@

\item Sort the results by score and display 2D a 3D diagram of the
best-scored triplex.

<<>>=
ts <- t[order(score(t),decreasing=TRUE)]
ts
@

\newpage

\setkeys{Gin}{width=.7\linewidth}
\begin{figure}[h]
\centering
<<fig=TRUE>>=
triplex.diagram(ts[1])
@
   \caption{2D diagram of detected triplex}
   \label{fig:triplex2d}
\end{figure}

\newpage

<<eval=FALSE>>=
triplex.3D(ts[1])
@

<<echo=FALSE>>=
triplex.alignment(ts[1])
@

\begin{figure}[h!]
\centering
   \includegraphics[width=.6\linewidth]{fig/triplex3d2}
   \caption{3D scheme of detected triplex}
   \label{fig:triplex3d}
\end{figure}

\newpage

\item Export all triplexes into a GFF3 format file.

<<>>=
library(rtracklayer)
export(as(t, "GRanges"),"test.gff", version="3")
@

The contents of the GFF3 file are as follows (the first 10 records only):

<<echo=FALSE>>=
text <- readLines("test.gff",n=10)
cat(strwrap(text, width=80, exdent=3),sep="\n")
@

\item Export all triplexes into a FASTA format file.

<<>>=
writeXStringSet(as(t, "DNAStringSet"), file="test.fa", format="fasta")
@

The contents of the FASTA file are as follows (the first 10 records only):

<<echo=FALSE>>=
text <- readLines("test.fa",n=20)
cat(text,sep="\n")
@

\item Show histogram for score distribution of detected triplexes.

<<fig=TRUE>>=
hist(score(t), breaks=20)
@

\item Show triplex distribution along the chromosome or other analysed sequence.

<<fig=TRUE>>=
plot(coverage(ts[0:length(t)]), type="s", col="grey75")
@

\end{enumerate}


\section{P-value calculation}
\label{sec:pvalue}
 
While calculating the scores of individual triplexes is
straightforward with given scoring matrices and
penalty scores, calculating reasonable P-values of these scores
is a challenging task.
 
The P-values describe the probability of obtaining the reported
scores by chance. To estimate it, we use a randomized genomic sequence.
Because of the strikingly different nucleotide and H-DNA content
of prokaryotic and eukaryotic sequences, we use E.coli genome and
a segment of human chromosome 5 as models. The calculation of P-value
follows the approach of \cite{Eddy1997}. We used the
ExtremeValueFitHistogram() function from hmmer-2.4 to fit the values
of $\lambda$ and $\mu$ in the equation:

\begin{equation}
\textit{P-value}(x) = 1 - e^{-n P(S \geq x)}
\end{equation}

where

\begin{equation}
P(S \geq x) = 1-e^{-e^{-\lambda(x - \mu)}}
\end{equation}

The problematic part here is the determination of $n$. Because we search
a single long sequence, but usually report multiple hits, the value of $n$
can only be estimated. It must take into account the internal filtering
of hits by \emph{triplex} and the filtering property of the DP algorithm
itself. We counted all the hits returned when fitting the EVD to a genome
of size 4.8Mbp, to find an apparent value of n:

\begin{equation}
n(4.8Mbp) = 170000
\end{equation}

This leads to a reported hit every 30bp, or a ratio of $n$ to sequence length:

\begin{equation}
rn = \frac{170000}{4800000} = 0.035
\end{equation}


\begin{thebibliography}{9}

\bibitem{Lexa2011}
   Lexa, M., Mart\'{i}nek, T., Burgetov\'{a}, I., Kope\u{c}ek, D., Br\'{a}zdov\'{a}, M.: \emph{A
   dynamic programming algorithm for identification of triplex-forming
   sequences}, In: Bioinformatics, Vol. 27, No. 18, 2011, Oxford, GB, p.
   2510-2517, ISSN 1367-4803.

\bibitem{Rajdl12}
   Rajdl, K.  \emph{Funkce pro manipulaci a vizualizaci molekul\'{a}rn\'{i}ch
   dat v prost\v{r}ed\'{i} R} [online].

\bibitem{Eddy1997}
   Eddy, S. R. \emph{Maximum likelihood fitting of extreme
   value distributions.} 1997. Unpublished technical notes. Available at
   http://www.genetics.wustl.edu/eddy/publications/

\end{thebibliography}


\end{document}

\name{ins}

\alias{ins}

\title{Insertions accessor}

\description{
  Gets the insertion vector of an object.
}

\usage{
ins(x, ...)
}

\arguments{
  \item{x}{An object to get the insertion values of.}
  \item{\dots}{Additional arguments.}
}

\examples{
t <- triplex.search(DNAString("TATTTATTTTTTCATCTTCTTTTTTTATTTTT"), max_len=11)
ins(t);
}

\keyword{methods}

\name{triplex-package}
\docType{package}

\alias{triplex-package}
\alias{triplex}

\title{Triplex search and visualization package}

\description{
This package provides functions for the identification and visualization
of potential intramolecular triplex (H-DNA) patterns in DNA sequences.
}

\details{
This package is essentially an R interface to the underlying C
implementation of a dynamic-programming search startegy of the same name
(Lexa et al., 2011). The main functionality of the original program was to detect
the positions of subsequences in a much larger sequence capable of folding
into an intramolecular triplex (H-DNA) made of as many cannonical nucleotide
triplets as possible (see \code{\link{triplex.search}}). In creating its
incarnation in R, we extended this
basic functionality, to include the calculation of exact base-pairing in the
triple helices, which allowed us to extend the functionality of the package
towards visualization showing the exact base-pairing in 1D, 2D or 3D (see
\code{\link{triplex.diagram}} and \code{\link{triplex.3D}}).
}

\author{
Matej Lexa, Tomas Martinek, Kamil Rajdl, Jiri Hon

Maintainer: Jiri Hon <jiri.hon@google.com>
}

\references{
Lexa, M., Martinek, T., Burgetova, I., Kopecek, D., Brazdova, M.: \emph{A
dynamic programming algorithm for identification of triplex-forming
sequences}, In: Bioinformatics, Vol. 27, No. 18, 2011, Oxford, GB, p.
2510-2517, ISSN 1367-4803
}

\seealso{
\code{\link{DNAString}},
\code{\link{triplex.search}},
\code{\link{triplex.diagram}},
\code{\link{triplex.3D}}
}

\examples{
seq <- DNAString("GGAAAGCAATGCCAGGCAGGG")
t <- triplex.search(seq, min_score=10, p_value=1)
triplex.diagram(t[1])
\dontrun{
triplex.3D(t[1])
}
triplex.score.table()
triplex.group.table()
}

\keyword{package}

\name{triplex.3D}
\alias{triplex.3D}

\title{
Triplex visualization, 3D representation 
}

\description{
This function visualizes a \code{\link{TriplexViews}} object as a 3D model.
Its structure can be drawn with automatic optimalizations.
To use this function, please install suggested rgl package from CRAN.
}

\details{
The input \code{\link{TriplexViews}} object is required to provide additional
algorithm options (see \code{\link{triplex.search}}). These are used for
proper computation of triplex alignment.

An example of a graphical output corresponding to a triplex type 3 with DNA
sequence "GGAAAGCAATGCCAGGCAGGG" is shown in the following figure

\if{text}{Figure: Example 3D visualization (see HTML or Latex version of this page)}
\figure{triplex3d.png}
}

\usage{
triplex.3D(triplex, opt = TRUE, A.col = "red", T.col = "brown", 
           G.col = "green", C.col = "blue", bbone.col = "violet", 
           bgr.col = "white", bbone.n = 20)
}

\arguments{
  \item{triplex}{
    \code{\link{TriplexViews}} object including only one triplex.
  }
  \item{opt}{
    TRUE or FALSE: TRUE - structure of triplex will be optimalized, FALSE -
    structure will be drawn without optimalization.
  }
  \item{A.col}{
    Color of Adine base.
  }
  \item{T.col}{
    Color of Thymin base.
  }
  \item{G.col}{
    Color of Guanine base.
  }
  \item{C.col}{
    Color of Cytosine base.
  }
  \item{bgr.col}{
    Color of background.
  }
  \item{bbone.col}{
    Color of backbone.
  }
  \item{bbone.n }{
    Number of sides of backbone bonds.
  }
}

\value{
Instance of \code{\link{DNAStringSet}} object with computed alignment.
}

\author{
Kamil Rajdl, Jiri Hon
}

\seealso{
\code{\link{triplex.diagram}},
\code{\link{triplex.search}},
\code{\link{triplex.alignment}}
}

\examples{
seq <- DNAString("GGAAAGCAATGCCAGGCAGGG")
t <- triplex.search(seq, min_score=10, p_value=1)
\dontrun{
triplex.3D(t[1])
}
}

\name{triplex.alignment}
\alias{triplex.alignment}

\title{
Triplex alignment
}

\description{
This function computes best triplex alignment.
}

\details{

Similarly to other DNA multiple sequence alignments the output of the
\code{triplex.alignment} method is stored as \code{\link{DNAStringSet}}
object. This object consists of four sequences: \code{plus} and \code{minus}
sequences representing 5' to 3' and 3' to 5' DNA strand of detected triplex;
one of the \code{anti-plus}, \code{anti-minus}, \code{para-plus} or
\code{para-minus} sequence representing the third triplex strand aligned to
\code{plus} or \code{minus} strand in \code{antiparallel} or \code{parallel}
fashion; and finally \code{loop} sequence representing unpaired loop.  

Please note that all eight triplex types shown in following
figure can be represented using four types of alignments, because each
alignment can correspond to triplex detected either on forward or reverse DNA
strand.

\if{text}{Figure: Triplex types (see HTML or Latex version of this page)}
\if{html}{\figure{types.png}{Figure: Triplex types}}
\if{latex}{\figure{types.pdf}{Figure: Triplex types}}

The input \code{\link{TriplexViews}} object is required to provide additional
algorithm options (see \code{\link{triplex.search}}). These are used for
proper computation of triplex alignment.
}

\usage{
triplex.alignment(triplex)
}

\arguments{
  \item{triplex}{
    \code{\link{TriplexViews}} object including only one triplex.
  }
}

\value{
Instance of \code{\link{DNAStringSet}} object.
}

\author{
Jiri Hon
}

\seealso{
\code{\link{triplex.diagram}},
\code{\link{triplex.3D}},
\code{\link{triplex.search}}
}

\examples{
seq <- DNAString("GGAAAGCAATGCCAGGCAGGG")
t <- triplex.search(seq, min_score=10, p_value=1)
triplex.alignment(t[1])
}

\name{triplex.search}
\alias{triplex.search}

\title{Search intramolecular triplex-forming sequences in DNA}

\description{
The \code{triplex.search} function identifies potential intramolecular
triplex-forming sequences in DNA.
}

\usage{
triplex.search(
  dna, 
  type        = 0:7,
  min_score   = 15,
  p_value     = 0.05,
  min_len     = 6,
  max_len     = 25,
  min_loop    = 3,
  max_loop    = 10,
  seq_type    = 'eukaryotic',
  score_table = 'default',
  group_table = 'default',
  lambda_par  = 'default',
  lambda_apar = 'default',
  mu_par      = 'default',
  mu_apar     = 'default',
  rn_par      = 'default',
  rn_apar     = 'default',
  dtwist_pen  = 'default',
  ins_pen     = 'default',
  iso_pen     = 'default',
  iso_bonus   = 'default',
  mis_pen     = 'default')
}

\arguments{
  \item{dna}{
    A \code{\link{DNAString}} object.
  }
  \item{type}{
    Vector of triplex types (0..7) to be searched for.
  }
  \item{min_score}{
    Minimal score treshold.
  }
  \item{p_value}{
    Acceptable P-value.
  }
  \item{min_len}{
    Minimal triplex length.
  }
  \item{max_len}{
    Maximal triplex length. 
  }
  \item{min_loop}{
    Minimal triplex loop length. Can not be lower than one.
  }
  \item{max_loop}{
    Maximal triplex loop length.
  }
  \item{seq_type}{
    Type of input sequence. Possible options: prokaryotic, eukaryotic.
  }
  \item{score_table}{
    Scoring table for parallel and antiparallel triplex types. Default
    is the same as \code{\link{triplex.score.table}} output.
    Before changing this option, please read \code{\link{triplex.score.table}}
    help carefully.
  }
  \item{group_table}{
    Isomorphic group table for parallel and antiparallel triplex types. Default
    is the same as \code{\link{triplex.group.table}} output.
    Before changing this option, please read \code{\link{triplex.group.table}}
    help carefully.
  }
  \item{lambda_par}{
    Lambda for parallel triplex types 0,1,2,3. Default for prokaryotic
    sequence is 0.8892, for eukaryotic 0.8433.
  }
  \item{lambda_apar}{
    Lambda for antiparallel triplex types 4,5,6,7. Default for prokaryotic
    sequence is 0.8092, for eukaryotic 0.6910.
  }
  \item{mu_par}{
    Mu for parallel triplex types 0,1,2,3. Default for prokaryotic
    sequence is 7.4805, for eukaryotic 0.8433.
  }
  \item{mu_apar}{
    Mu for antiparallel triplex types 4,5,6,7. Default for prokaryotic
    sequence is 7.6569, for eukaryotic 7.9611.
  }
  \item{rn_par}{
    Hit ratio (reported hits to sequence length) for parallel triplex
    types 0,1,2,3.
    
    Default for prokaryotic sequence is 0.0406, for eukaryotic 0.0304.
  }
  \item{rn_apar}{
    Hit ratio (reported hits to sequence length) for antiparallel triplex
    types 4,5,6,7.
    
    Default for prokaryotic sequence is 0.0273, for eukaryotic 0.0405.
  }
  \item{dtwist_pen}{
    Dtwist penalization, default is 7.
  }
  \item{ins_pen}{
    Insertion penalization, default is 9.
  }
  \item{iso_pen}{
    Isomorphic group change penalization, default is 5.
  }
  \item{iso_bonus}{
    Isomorphic group stay bonus, default is 0.
  }
  \item{mis_pen}{
    Mismatch penalization, default is 7.
  }
}


\note{

If you modify the penalization options (\code{dtwist_pen}, \code{ins_pen},
\code{iso_pen}, \code{iso_bonus}, \code{mis_pen}), scoring tables (\code{score_table})
or isogroup tables (\code{group_table}),
you should consider changing also default P-value constants (\code{lambda},
\code{mu} and \code{rn}) to get relevant P-values.

}

\details{

The \code{triplex.search} function identifies potential intramolecular
triplex-forming sequences in DNA sequence represented as
a \code{\link{DNAString}} object.

Based on triplex position (forward or reverse strand) and its third strand
orientation, up to 8 types of triplexes are distinguished by the function (see
the following figure). By default, the function detects all 8 types, however 
this behavior can be changed by setting the \code{type} parameter to any value
or a subset of values in the range 0 to 7.

\if{text}{Figure 1: Triplex types (see HTML or Latex version of this page)}
\if{html}{\figure{types.png}{Figure 1: Triplex types}}
\if{latex}{\figure{types.pdf}{Figure 1: Triplex types}}

Detected triplexes are returned as instances of the 
\code{\link{TriplexViews}} class,
which represents the basic container for storing a set of views on the same
input sequence similarly to the \code{\link{XStringViews}} object (in fact
\code{\link{TriplexViews}} only extends the \code{\link{XStringViews}} class
with a number of displayed columns). Each triplex view is defined by start
and end locations, width, score, P-value, number of insertions, type, strand, loop
start and loop end.  Please note, that the strand orientation depends on
triplex type only. The \code{triplex.search} function assumes that the input
DNA sequence represents the forward strand.

Basic requirements for the shape or length of detected triplexes can be
defined using four parameters: \code{min_len}, \code{max_len},
\code{min_loop} and \code{max_loop}. While \code{min_len} and \code{max_len}
specify the length of the triplex stem composed of individual triplets,
\code{min_loop} and \code{max_loop} parameters define the range of lengths
for the unpaired loop at the top of the triplex. A graphical representation of
these parameters is shown in the following figure.  Please note, these 
parameters also impact the overall computation time. For longer triplexes, 
larger space has to be explored and thus more computation time is consumed. 

\if{text}{Figure 2: Triplex scheme (see HTML or Latex version of this page)}
\if{html}{\figure{triplex.png}{Figure 2: Triplex scheme}}
\if{latex}{\figure{triplex.pdf}{Figure 2: Triplex scheme}}

The quality of each triplex is represented by its score value. A higher score
value represents a higher-quality triplex. This quality is decreased by several
types of imperfections at the level of triplets, such as character mismatch,
insertion, deletion, isomorphic group change etc. Penalization constants for
these imperfections can be setup using the following parameters: \code{mis_pen},
\code{ins_pen}, \code{iso_pen}, \code{iso_bonus} and
\code{dtwist_pen}. Detailed information about the scoring function and
penalization parameters can be found in (Lexa et al., 2011). It is highly
recommended to see (Lexa et al., 2011) prior to changing any penalization 
parameters.

The \code{triplex.search} function can output a large list containing tens of
thousands of potential triplexes. The size of these results can be reduced
using two filtration mechanisms: (1) by specifying the minimal acceptable
score value using the \code{min_score} parameter or (2) by specifying the
maximum acceptable P-value of results using the \code{p_value} parameter. The
P-value represents the probability of occurrence of detected triplexes in
random sequence. By default, only triplexes with P-value equal or less than
0.05 are reported. Calculation of P-value depends on two extreme value
distribution parameters \code{lambda} and \code{mi}.  By default, these
parameters are set up for searching in human genome sequences. It is highly
recommended to see (Lexa et al., 2011) prior to changing either of the
\code{lambda} and \code{mi} parameters.

}

\value{
Instance of \code{\link{TriplexViews}} object based on
\code{\link{XStringViews}} class.
}

\references{
Lexa, M., Martinek, T., Burgetova, I., Kopecek, D., Brazdova, M.: \emph{A
dynamic programming algorithm for identification of triplex-forming
sequences}, In: Bioinformatics, Vol. 27, No. 18, 2011, Oxford, GB, p.
2510-2517, ISSN 1367-4803
}

\author{
Matej Lexa, Tomas Martinek, Jiri Hon
}

\seealso{
\code{\link{TriplexViews}},
\code{\link{triplex.score.table}}
\code{\link{triplex.group.table}}
\code{\link{triplex.diagram}},
\code{\link{triplex.3D}},
\code{\link{triplex.alignment}}
}

\examples{
# GAA triplet repeats involved in Friedreichs's ataxia
seq <- DNAString("GAAGAAGAAGAAGAAGAAGAAGAAGAAGAA")

# Search specific triplex types (see details section)
triplex.search(seq, type=c(2,3), min_score=10, p_value=1)

# Search all triplex types
t <- triplex.search(seq, min_score=10, p_value=1)

# Sort triplexes by score
t[order(score(t), decreasing=TRUE)]
}

\keyword{interface}

\name{triplex.group.table}
\alias{triplex.group.table}

\title{Get default isogroup tables}

\description{
The \code{triplex.group.table} function returns default isogroup tables
for parallel and antiparallel triplex types.
}

\usage{
triplex.group.table()
}

\details{

This function is used by \code{\link{triplex.search}} function to get
default isogroup tables. These tables correspond exactly with Table 1 published
in (Lexa, 2011) and they represent the isomorphic groups of triplets.

As a common triplet structure is H.WC:WC, to customize isogroup tables
just use H as a row index, WC as a column index, then set desired group number and
pass such modified tables through \code{group_table} option of \code{\link{triplex.search}}
interface.

}

\value{
List of two matrixes, one for parallel triplex types and the other one
for antiparallel.
}

\note{

If you modify the isogroup tables,
you should consider changing also default P-value constants (\code{lambda},
\code{mu} and \code{rn}), because these are valid just for the default isogroup tables.

}

\references{
Lexa, M., Martinek, T., Burgetova, I., Kopecek, D., Brazdova, M.: \emph{A
dynamic programming algorithm for identification of triplex-forming
sequences}, In: Bioinformatics, Vol. 27, No. 18, 2011, Oxford, GB, p.
2510-2517, ISSN 1367-4803
}

\author{
Tomas Martinek, Jiri Hon
}

\seealso{
\code{\link{triplex.score.table}}
\code{\link{triplex.search}},
\code{\link{TriplexViews}},
\code{\link{triplex.diagram}},
\code{\link{triplex.3D}},
\code{\link{triplex.alignment}}
}

\examples{
triplex.group.table()
}

\name{pvalue}

\alias{pvalue}

\title{P-value accessor}

\description{
  Gets the P-values of an object.
}

\usage{
pvalue(x, ...)
}

\arguments{
  \item{x}{An object to get the P-values of.}
  \item{\dots}{Additional arguments.}
}

\examples{
t <- triplex.search(DNAString("TATTTATTTTTTCATCTTCTTTTTTTATTTTT"))
pvalue(t);
}

\keyword{methods}

\name{lwidth}

\alias{lwidth}

\title{Loop width accessor}

\description{
  Gets the loop widths of an object.
}

\usage{
lwidth(x, ...)
}

\arguments{
  \item{x}{An object to get the loop width values of.}
  \item{\dots}{Additional arguments.}
}

\examples{
t <- triplex.search(DNAString("TATTTATTTTTTCATCTTCTTTTTTTATTTTT"))
lwidth(t);
}

\keyword{methods}

\name{TriplexViews-class}
\docType{class}

% Class:
\alias{class:TriplexViews}
\alias{TriplexViews-class}
\alias{TriplexViews}
\alias{TriplexViews-constructor}

% Methods:
\alias{show,TriplexViews-method}
\alias{score,TriplexViews-method}
\alias{pvalue,TriplexViews-method}
\alias{ins,TriplexViews-method}
\alias{type,TriplexViews-method}
\alias{lstart,TriplexViews-method}
\alias{lwidth,TriplexViews-method}
\alias{lend,TriplexViews-method}
\alias{strand,TriplexViews-method}
\alias{as.character,TriplexViews-method}
\alias{toString,TriplexViews-method}

\title{The TriplexViews class}

\description{
The TriplexViews class is a container for storing a set of triplexes
identified in the same DNA sequence (an \code{\link{DNAString}} object).
Each triplex is defined by its start/end locations, score, P-value,
insertion number, type, loop start, loop end and strand identification.

TriplexViews object contains also a parameter vector plus score and group tables
that stores custom algorithm options that were used for triplex search.
This is necessary for proper triplex visualization by \code{\link{triplex.diagram}}
and \code{\link{triplex.3D}} functions.
}

\details{
A TriplexViews object is in fact a particular case of an
\link[Biostrings:XStringViews-class]{XStringViews} 
object (the TriplexViews class contains the
\link[Biostrings:XStringViews-class]{XStringViews} class) so it 
can be manipulated in a similar manner. See
\code{?\link[Biostrings:XStringViews-class]{XStringViews}} for 
detailed information.

If you are interested in algorithm options that are stored in
the TriplexViews object, see parameters of \code{\link{triplex.search}}
function. These options are required by visualization functions for
proper computation of triplex alignment.
}

\section{Constructor}{
\describe{
There is no public constructor for TriplexViews object as it
stores search algorithm options. TriplexViews object would not be useful
without algorithm options attached. For more information see description
or details.
}
}

\section{Accessor-like methods}{
All the accessor-like methods defined for
\link[Biostrings:XStringViews-class]{XStringViews} objects
work on TriplexViews objects. In addition, the following accessors are
defined for TriplexViews objects:

	\describe{
	\item{}{
	\code{score(x)}:
	A vector of non-negative integers containing the scores of triplexes.
	}
	\item{}{
	\code{pvalue(x)}:
	A vector of non-negative doubles containing the P-values of triplexes.
	}
	\item{}{
	\code{ins(x)}:
	A vector of non-negative integers containing the number of insertions/deletions
	in triplexes.
	}
	\item{}{
	\code{type(x)}:
	A vector of non-negative integers containing the triplex type.
	}
	\item{}{
	\code{lstart(x)}:
	A vector of non-negative integers containing the triplex loop starts.
	}
	\item{}{
	\code{lwidth(x)}:
	A vector of non-negative integers containing the triplex loop widths.
	}
	\item{}{
	\code{lend(x)}:
	A vector of non-negative integers containing the triplex loop ends.
	}
	\item{}{
	\code{strand(x)}:
	A vector of '+' or '-' signs to identify on which strand the triplex was found.
	}
	\item{}{
	\code{toString(x)}:
	Converts \code{TriplexViews} object into vector of strings.
	}
	}
}

\note{
The only standard way to create a TriplexViews object
is to use \code{\link{triplex.search}} function.
}

\author{Jiri Hon}

\seealso{
\code{\link{triplex.search}},
\code{\link{triplex.diagram}},
\code{\link{triplex.3D}},
\code{\link{XStringViews}},
\code{\link{triplex.alignment}}
}

\examples{  
seq <- DNAString("GAAGAAGAAGAAGAAGAAGAAGAAGAAGAA")
t <- triplex.search(seq, min_score=10, p_value=1)
start(t)
end(t)
score(t)
pvalue(t)
ins(t)
type(t)

# Search triplex with maximal score
t[score(t) == max(score(t))]

# Sort triplexes by score
t[order(score(t), decreasing=TRUE)]
}

\keyword{methods}
\keyword{classes}

\name{triplex.diagram}
\alias{triplex.diagram}

\title{
Triplex visualization, diagram representation 
}

\description{
This function visualizes a \code{\link{TriplexViews}} object as a 2D diagram.
Nucleotides are drawn as characters in circles and bonds as lines between
 them (Watson-Crick or Hogsteen).
}

\details{
The input \code{\link{TriplexViews}} object is required to provide additional
algorithm options (see \code{\link{triplex.search}}). These are used for
proper computation of triplex alignment.

An example of a graphical output corresponding to a triplex of type 3 with 
DNA sequence "GGAAAGCAATGCCAGGCAGGG" is shown in the following figure

\if{text}{Figure: Example 2D visualization (see HTML or Latex version of this page)}
\figure{triplex2d.png}
}

\usage{
triplex.diagram(triplex, circles = TRUE, mbonds.lty = 1, 
                mbonds.lwd = 2.5, wcbonds.lty = 1, wcbonds.lwd = 1, 
                hbonds.lty = 2, hbonds.lwd = 1, labels.cex = 1, circles.cex = 1,
                margin = 0.1, bonds.length = 0.07)
}

\arguments{
  \item{triplex}{
    \code{\link{TriplexViews}} object including only one triplex.
  }
  \item{circles}{
    TRUE or FALSE: TRUE - nucleotides are drawn as characters in circles, FALSE -
    nucleotides are drawn just as characters.
  }
  \item{mbonds.lty}{
    Type of main (skelet) bonds lines.
  }
  \item{mbonds.lwd}{
    Width of main (skelet) bonds lines.
  }
  \item{wcbonds.lty}{
    Type of Watson-Crick bonds lines.
  }
  \item{wcbonds.lwd}{
    Width of Watson-Crick bonds lines.
  }
  \item{hbonds.lty}{
    Type of Hoogsteen bonds lines.
  }
  \item{hbonds.lwd}{
    Width of Hoogsteen bonds lines.
  }
  \item{labels.cex}{
    Multiplier of size of labels of nucleotides.
  }
  \item{circles.cex}{
    Multiplier of size of nucleotides.
  }
  \item{margin}{
    Left and right margin of the picture.
  }
  \item{bonds.length}{
    Length of lines representing Watson-Crick and Hoogsteen bonds.
  }
}

\value{
Instance of \code{\link{DNAStringSet}} object with computed alignment.
}

\author{
Kamil Rajdl, Jiri Hon
}

\seealso{
\code{\link{triplex.3D}},
\code{\link{triplex.search}},
\code{\link{triplex.alignment}}
}

\examples{
seq <- DNAString("GGAAAGCAATGCCAGGCAGGG")
t <- triplex.search(seq, min_score=10, p_value=1)
triplex.diagram(t[1])
}
